C
C     H E C   2 2   /   FORTRAN 77  release 18                          REL.18
C
C     April 21, 2016 control prints removed                             REL.18
C
C     Reductions of UBV, UBVR or uvby photoelectric observations
C                         by
C                   Petr Harmanec
C                   Astronomical Institute of the Charles University    REL.14.1
C                   V Holesovickach 2                                   REL.14.1
C           180 00  Praha 8 - Troja                                     REL.14.1
C                   Czech Republic
C                   e-mail: hec@mail.asu.cas.cz                         REL.18
C                           Petr.Harmanec@mff.cuni.cz                   REL.18
C
C
C   --------------------------                                          REL.14.1
C     Labels up to 1052 used                                            REL.18
C   --------------------------                                          REL.14.1
C
C     Solution with colour extinction coefficients included             REL.13
C              among the seasonal coefficients
C
C     All transformation equations are in magnitudes                    REL.13
C
C     New features of rel. 13 include:                                  REL.13
C         1. a possibility to choose cubic, bilinear or linear          REL.13
C            transformation equations individually for each passband    REL.13
C            key 12 = abcde                                             REL.13
C            a=W, b=U, c=B, d=V                                         REL.13
C            0..cubic, 1..bilinear, 2..linear                           REL.13
C         2. the maximum allowed number of individual observations      REL.13
C            per night was increased to 350                             REL.13
C                                                                       REL.13
C         3. it is possible to create normal points over specific       REL.13
C            time interval in subroutine DATA to handle unequal number  REL.13
C            of observations through different passbands; the limitationREL.13
C            is that these normal points with their mean times only     REL.13
C            are used in the main program to calculate air mass, colour REL.13
C            extinction, etc.                                           REL.13
C
C         4. a minor error in extinction calculation was corrected      REL.13
C
C         5. input of another Table of objects is now possible          REL.13
C
C         Rel. 13.1:                                                    REL.13.1
C         6. rms errors of the mean values for individual stars         REL.13.1
C            are now errors per 1 observation, not errors of            REL.13.1
C            the mean as in all previous versions                       REL.13.1
C
C         Rel. 13.2:
C         7. Bemporad's more accurate formula for air mass is now used  REL.13.2
C
C         Rel. 13.3:                                                    REL.13.3
C         A minor inacurracy in the determination of the reference      REL.13.3
C         epoch for solar orbit determination was corrected             REL.13.3
C         and all zero points are now referred to the time centre       REL.13.3
C         of the observations                                           REL.13.3
C
C
C         New features of rel. 14:                                      REL.14
C                                                                       REL.14
C         1. An important possibility to model a time-variable          REL.14
C            linear extinction was introduced                           REL.14
C            This implies a large change in controlling the run         REL.14
C            of the program via key 6 in the control record             REL.14
C            The following options are now possible:                    REL.14
C            --------------------------------------------------------   REL.14
C             K6K          action                                       REL.14
C            --------------------------------------------------------   REL.14
C               0    linear extinction is derived and used as before    REL.14
C               1    linear extinction is kept at fixed values          REL.14
C              10    linear extinction and a linear trend of the zero   REL.14
C                    point of the magnitude scale are derived via       REL.14
C                    observations in passband 1 and the trend is        REL.14
C                    then kept fixed before extinction for other        REL.14
C                    passbands is calculated                            REL.14
C              11    linear extinction is kept at fixed values          REL.14
C                    and a linear trend of the zero point of            REL.14
C                    magnitude scale is derived via observations        REL.14
C                    in passband 1 and kept the same for the            REL.14
C                    observation in remaining passbands                 REL.14
C              20    linear extinction and a quadratic trend of         REL.14
C                    the zero point - see K6K=10 for details            REL.14
C              21    fixed linear extinction and a quadratic trend      REL.14
C                    of the zero point - see K6K=11 for details         REL.14
C           100-500  a time-variable extinction is derived and          REL.14
C                    modelled as a polynomial of 1st to 5th degree      REL.14
C            Note that one should now take care how to use these        REL.14
C            options, considering that for the next night, all          REL.14
C            nightly transformation coefficients G are set to zero      REL.14
C            but the linear extinction G5 to G8 which keeps the values  REL.14
C            derived or specified in the previous night                 REL.14
C                                                                       REL.14
C         2. A new regime K1K=3 was implemented which allows            REL.14
C            to reduce instrumental colour to B-V                       REL.14
C            using (b-v)_0 = H1*(B-V)+H5*CE(B-V,X)+H6                   REL.14
C            (a linear relation which includes the usual                REL.14
C            colour extinction)                                         REL.14
C            Originally designed to allow reduction of                  REL.14
C            colorimetric data from Zollner photometer                  REL.14
C                                                                       REL.14
C         3. The original subroutine to derive geocentric Julian date   REL.14
C            was replaced by a more universal Vondrak's function GEO    REL.14
C                                                                       REL.14
C         4. There can be up to 900 differential as well as all-sky     REL.14
C            observations                                               REL.14
C                                                                       REL.14
C         5. Only data from nights denoted as suitable for all-sky      REL.14
C            photometry are exported to the all-sky data archive        REL.14
C
C         6. A graphical display of the O-C deviations for standard     REL.14
C            stars defining the nightly transformation in individual    REL.14
C            passbands if now possible when one specifies K11K>9        REL.14
C
C         New features of rel. 14.1:                                    REL.14.1
C                                                                       REL.14.1
C         It is taken care of Fortran error that a sign of zero         REL.14.1
C         is always interpreted as +0 which introduced errors           REL.14.1
C         for declinations as -0 12 15 etc.                             REL.14.1
C                                                                       REL.14.1
C                                                                       REL.15
C         New features of rel. 15:                                      REL.15
C                                                                       REL.15
C         New type E data introduced for K5K=4                          REL.15
C
C         Table of objects can contain up to 2000 objects               REL.15
C            In that case, one has to use |K8K|>9                       REL.15
C            and Table of objects with all columns shifted              REL.15
C            for 1 position to the right                                REL.15
C
C         Mean times of each observation in NC (1-4) filters            REL.15
C         are now derived as an average of the individual               REL.15
C         mean times in filters 1-NC (Oct.15, 2005)                     REL.15
C
C         Rel. 16 introduces an option to use the sky measured          REL.16
C         immediately after each observed object, not interpolated one  REL.16
C         So far realized for data E only, choose K5K=-4                REL.16

C         Rel. 16.1: geographic coordinates of Villanova Observatory    REL.16.1
C         are now coordinates of Fairborn Observatory, where APT T5     REL.16.1
C         is located since 1996.                                        REL.16.1
C
C         Rel. 16.2: an error in subroutine MAG in the calculation      REL.16.2
C         of EXT(4) was corrected. All previous versions deriving       REL.16.2
C         a polynomial fit to extinction during the night malfunctioned REL.16.2
C         for the fourth magnitude (e.g. v in Stromgren)!               REL.16.2
C         Improved geographic coordinates of the Danish 1.52-m          REL.16.2
C         La Silla telescope were also implemented                      REL.16.2
C         Note that built-in correction of La Silla local time          REL.16.2
C         UT=LOCAL+5 is only valid from April to October, it must       REL.16.2
C         be set to 4 hours for observations from other months          REL.16.2
C         Print of O-C during the night is now supressed if             REL.16.2
C         only 1 extinction star was observed, this led                 REL.16.2
C         to a segmentation fault error                                 REL.16.2
C
C         Rel 17: A principal change: Data archives output              REL.17
C                 as plain ASCII files in fixed format, which is        REL.17
C                 modified with respect to all previous versions:       REL.17
C                 a space is added before station number to allow       REL.17
C                 also stations with Nos. > 99. See output formats      REL.17
C                 235 and 2235, for UBV and uvby, respectively          REL.17
C                 Modified program VYPAR rel. 7.0 must be used          REL.17
C                 for all operations with these new archives            REL.17
C
C         Rel. 17.1: A bug causing SEGMENTATION FAULT error when        REL.17.1
C                 a plot was required for CCD data from a single frame  REL.17.1
C                 i.e. with all times of observations identical         REL.17.1
C                 It was also ensured that for missing observations     REL.17.1
C                 output data to both archives are 99.999               REL.17.1
C
C         Rel.18: Another principal change, which concerns              REL.18
C                 the four-colour photometry only:                      REL.18
C                 Table of objects no longer contains the values        REL.18
C                 of the fouth magnitude, but the colour index          REL.18
C                 u-v for the Stromgren photometry                      REL.18
C                 and V-R for the UBVR photometry                       REL.18
C                 An auxiliary program TABU helps to convert            REL.18
C                 an existing Table of objects with four magnitudes     REL.18
C                 to the new form with colour indices.                  REL.18
C                 Since one cannot use the same scheme in the order     REL.18
C                 of magnitudes and indices, this version is now        REL.18
C                 made specifically designed to deal with               REL.18
C                 the UBV, UBVR or uvby photometry                      REL.18
C                 The distinction is being made with the highest third  REL.18
C                 digit of the first key K1K:                           REL.18
C                    0 and 3-colour photometry: UBV                     REL.18
C                    1 and 3-colour photometry: VBR                     REL.18
C                    0 and 4-colour photometry: uvby                    REL.18
C                    1 and 4-colour photometry: URVR                    REL.18
C                 The headers are printed accordingly                   REL.18
C                 On Sep. 11, 2014 extended to 100000 observetions      REL.18
C                 during one night and 10000 extinction-star obs.       REL.18
C                 (the latter concerns GRAF subroutine - can also       REL.18
C                  extended if necessary)                               REL.18
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
  101 FORMAT(12I5,3I3,1X,5A2)
  102 FORMAT(5A8,2X)
  103 FORMAT(F3.0,I3,I5,3I2,I3,4F10.5)                                  REL.17
  104 FORMAT(7F10.5,A8)
  105 FORMAT(I3,I2,F5.0,3F4.0,F5.0,2F4.0,3F7.3,I11,3A4)
  106 FORMAT(8F10.5)
  107 FORMAT(3I2)
  108 FORMAT(I10,4F10.3)
  109 FORMAT(I3,I2,F5.0,3F3.0,F4.0,2F3.0,4F7.3,I10,3A4)
 2109 FORMAT(I4,I2,F5.0,3F3.0,F4.0,2F3.0,4F7.3,I10,3A4)                 REL.15
  110 FORMAT(80A1)                                                      REL.14.1
C
  200 FORMAT(//15X,24(2H* ),1H*/15X,1H*,47X,1H*/15X,1H*,3X,
     1      'H E C   2 2',8X,'IBM PC 486 / FORTRAN 77',2X,1H*
     2      /15X,1H*,47X,1H*/15X,1H*,3X,
     3      'R e l e a s e   18           21 April 2016',2X,1H*         REL.18
     4      /15X,1H*,47X,1H*/15X,24(2H* ),1H*//)
  201 FORMAT(1X,I4,2X,3A4,I8,I5,I7,2(F5.0,2F7.2),4F8.3)                 REL.17
 2201 FORMAT(1X,80A1)                                                   REL.15
22201 FORMAT(80A1)                                                      REL.15
  202 FORMAT(5X,'The zero coefficients in y, b, u and v:'/
     *       13X,4F10.5/)                                               REL.14
 2202 FORMAT(5X,'The zero coefficients in V, B, U and R:'/              REL.18
     *       13X,4F10.5/)                                               REL.18
 3202 FORMAT(5X,'The zero coefficients in V, B, and R:'/                REL.18
     *       13X,3F10.5/)                                               REL.18
 4202 FORMAT(5X,'The zero coefficients in V, B, and U:'/                REL.18
     *       13X,3F10.5/)                                               REL.18
  203 FORMAT(/5X,'The extinction coefficients used:'/                   REL.18
     1       19X,1HV,9X,1HB,9X,1HU/                                     REL.18
     2       ' first-order:',3F10.5,2X,A8/                              REL.18
     3       'second-order:',3F10.5,2X,A8/)                             REL.18
 2203 FORMAT(/5X,'The extinction coefficients used:'/                   REL.18
     1       19X,1Hy,9X,1Hb,9X,1Hu,9X,1Hv/                              REL.18
     2       ' first-order:',4F10.5,2X,A8/                              REL.18
     3       'second-order:',4F10.5,2X,A8/)                             REL.18
 3203 FORMAT(/5X,'The extinction coefficients used:'/                   REL.18
     1       19X,1HV,9X,1HB,9X,1HU,9X,1HR/                              REL.18
     2       ' first-order:',4F10.5,2X,A8/                              REL.18
     3       'second-order:',4F10.5,2X,A8/)                             REL.18
 4203 FORMAT(/5X,'The extinction coefficients used:'/                   REL.18
     1       19X,1HV,9X,1HB,9X,1HR/                                     REL.18
     2       ' first-order:',3F10.5,2X,A8/                              REL.18
     3       'second-order:',3F10.5,2X,A8/)                             REL.18
  204 FORMAT(1X,A2,1X,3A4,F5.0,F7.2,F8.4,17F8.3)
  205 FORMAT(//40X,34(1H*)/43X,3A4,'   (HD',I7,1H)/40X,34(1H*)//
     1       5X,'Local time',6X,'JD hel',9X,1HV,8X,1HB,8X,1HU,
     2       7X,3HB-V,6X,3HU-B,7X,1HX,6X,5HV dif,3X,
     3       'B-V dif  U-B dif     DX   HD comp'/
     4       8X,1Hh,6X,1Hm)
 1205 FORMAT(//40X,34(1H*)/43X,3A4,'   (HD',I7,1H)/40X,34(1H*)//        REL.18
     1       5X,'Local time',6X,'JD hel',9X,1HV,8X,1HB,8X,1HU,          REL.18
     2       8X,1HR,7X,3HB-V,6X,3HU-B,6X,3HV-R,7X,1HX,6X,5HV dif,3X,    REL.18
     3       'B-V dif  U-B dif  V-R dif     DX   HD comp'/              REL.18
     4       8X,1Hh,6X,1Hm)                                             REL.18
 2205 FORMAT(//40X,34(1H*)/43X,3A4,'   (HD',I7,1H)/40X,34(1H*)//
     1       5X,'Local time',6X,'JD hel',9X,1HV,8X,1Hb,8X,1Hu,          REL.18
     2       8X,1Hv,7X,3Hb-y,6X,3Hu-b,6X,3Hu-v,7X,1HX,6X,5HV dif,3X,    REL.18
     3       'b-y dif  u-b dif  u-v dif     DX   HD comp'/              REL.18
     4       8X,1Hh,6X,1Hm)                                             REL.18
 3205 FORMAT(//40X,34(1H*)/43X,3A4,'   (HD',I7,1H)/40X,34(1H*)//        REL.18
     1       5X,'Local time',6X,'JD hel',9X,1HV,8X,1HB,8X,1HR,          REL.18
     2       7X,3HB-V,6X,3HV-R,7X,1HX,6X,5HV dif,3X,                    REL.18
     3       'B-V dif  V-R dif     DX   HD comp'/                       REL.18
     4       8X,1Hh,6X,1Hm)                                             REL.18
  206 FORMAT(3X,F5.0,F7.2,F15.4,8F9.3)                                  REL.18
  207 FORMAT(6X,2HV:,6F10.5/6X,2HB:,6F10.5/
     *       6X,2HU:,6F10.5/6X,2HW:,6F10.5/)
  208 FORMAT(//15X,49(1Ho),15X/27X,
     1       'Date:',I6,2H -,I3,2H -,F4.0,1H/,F3.0/
     2       80(1Ho)/10A8/80(1Ho))
  209 FORMAT(35X,'Key option:'/12I5,3I3,1X,5A2/80(1H-))
  210 FORMAT(32X,'Observatory ',A8/
     1       28X,1Hh,7X,1Hm,23X,1Ho,7X,1H//
     2       '  Geographic coordinates:',
     3       I3,F8.3,2X,A4,' of Greenwich',I5,F8.3,A8/80(1H-))
  211 FORMAT(5X,'Corrections to the U.T.:',3X,'U.T.(hours) =',
     1      ' Local time + PAS + CTIME/60;'/15X,'PAS =',F9.4,
     2       ' hours   CTIME =',F10.3,' minutes'/80(1H=))
  212 FORMAT(2X,3HNo.,1X,'Epoch',4X,                                    REL.14.1
     1       'R.A.',5X,'Decl.',5X,1HV,6X,3HB-V,4X,                      REL.14.1
     2       3HU-B,5X,1H ,7X,2HHD,5X,'Star Name'/                       REL.14.1
     3       4X,'Type'/                                                 REL.14.1
     4       80(1H-)/                                                   REL.14.1
     5       14X,1Hh,2X,1Hm,2X,1Hs,3X,1Ho,2X,1H/,2X,2H//)               REL.14.1
 2212 FORMAT(2X,3HNo.,1X,'Epoch',4X,                                    REL.18
     1       'R.A.',5X,'Decl.',5X,1HV,5X,3Hb-y,4X,                      REL.18
     2       3Hu-b,4X,3Hv-u,5X,2HHD,5X,'Star Name'/                     REL.18
     3       4X,'Type'/                                                 REL.18
     4       80(1H-)/                                                   REL.18
     5       14X,1Hh,2X,1Hm,2X,1Hs,3X,1Ho,2X,1H/,2X,2H//)               REL.18
 3212 FORMAT(2X,3HNo.,1X,'Epoch',4X,                                    REL.18
     1       'R.A.',5X,'Decl.',5X,1HV,6X,3HB-V,4X,                      REL.18
     2       3HU-B,4X,3HV-R,5X,2HHD,5X,'Star Name'/                     REL.18
     3       4X,'Type'/                                                 REL.18
     4       80(1H-)/                                                   REL.18
     5       14X,1Hh,2X,1Hm,2X,1Hs,3X,1Ho,2X,1H/,2X,2H//)               REL.18
 4212 FORMAT(2X,3HNo.,1X,'Epoch',4X,                                    REL.18
     1       'R.A.',5X,'Decl.',5X,1HV,5X,3HB-V,4X,                      REL.18
     2       3HV-R,5X,1H ,7X,2HHD,5X,'Star Name'/                       REL.18
     3       4X,'Type'/                                                 REL.18
     4       80(1H-)/                                                   REL.18
     5       14X,1Hh,2X,1Hm,2X,1Hs,3X,1Ho,2X,1H/,2X,2H//)               REL.18
  213 FORMAT(5X,'Gains in magnitudes:')
  214 FORMAT(52X,'The standard stars used'//56X,
     1       'Computed',28X,'Computed-standard'//8X,'Star name',2X,
     2       'Local time',2X,'JD geo',4X,1HV,7X,1HB,7X,1HU,7X,
     3       3HB-V,5X,3HU-B,5X,2HDV,6X,2HDB,6X,2HDU,4X,
     4       'D(B-V)',2X,'D(U-B)',4X,1HX,7X,2HkV,6X,2HkB,6X,2HkU/       REL.14
     5       20X,1Hh,4X,1Hm,I10,1H+)
 2114 FORMAT(22X,'The standard stars used'//37X,                        REL.14
     1       'Computed',1X,'Comp-std'//8X,'Star name',2X,               REL.14
     2       'Local time',2X,'JD geo',4X,3HB-V,3X,'D(B-V)',5X,1HX,      REL.14
     3       6X,2HkV/20X,1Hh,4X,1Hm,I10,1H+)                            REL.14
 2214 FORMAT(52X,'The standard stars used'//56X,
     1       'Computed',28X,'Computed-standard'//8X,'Star name',2X,
     2       'Local time',2X,'JD geo',4X,1HV,7X,1Hb,7X,1Hu,7X,1Hv,7X,
     3       3Hb-y,5X,3Hu-b,5X,2HDV,6X,2HDb,6X,2HDu,6X,2HDv,4X,
     4       'D(b-y)',2X,'D(u-b)',4X,1HX,7X,2HkV,6X,2Hkb,6X,2Hku,6X,    REL.14
     5       2Hkv/20X,1Hh,4X,1Hm,I10,1H+)                               REL.14
 3214 FORMAT(52X,'The standard stars used'//56X,                        REL.18
     1       'Computed',28X,'Computed-standard'//8X,'Star name',2X,     REL.18
     2       'Local time',2X,'JD geo',4X,1HV,7X,1HB,7X,1HU,7X,1HR,7X,   REL.18
     3       3HB-V,5X,3HU-B,5X,2HDV,6X,2HDB,6X,2HDU,6X,2HDR,4X,         REL.18
     4       'D(B-V)',2X,'D(U-B)',4X,1HX,7X,2HkV,6X,2HkB,6X,2HkU,6X,    REL.18
     5       2HkR/20X,1Hh,4X,1Hm,I10,1H+)                               REL.18
 4214 FORMAT(52X,'The standard stars used'//56X,                        REL.18
     1       'Computed',28X,'Computed-standard'//8X,'Star name',2X,     REL.18
     2       'Local time',2X,'JD geo',4X,1HV,7X,1HB,7X,1HR,7X,          REL.18
     3       3HB-V,5X,3HV-R,5X,2HDV,6X,2HDB,6X,2HDR,4X,                 REL.18
     4       'D(B-V)',2X,'D(V-R)',4X,1HX,7X,2HkV,6X,2HkB,6X,2HkR/       REL.18
     5       20X,1Hh,4X,1Hm,I10,1H+)                                    REL.18
  215 FORMAT   (4X,4Hrms:,4F10.4/)
  216 FORMAT(/80(1H-)//1X,I4,'.iteration'/)
  217 FORMAT(/7X,'Mean:',F18.4,5F9.3,9X,3F9.3)
 2217 FORMAT(/7X,'Mean:',F18.4,7F9.3,9X,4F9.3)
  218 FORMAT (/72X,4Hrms:,6F8.3/)
 2218 FORMAT (/80X,4Hrms:,6F8.3/)
 2318 FORMAT (/40X,4Hrms:,F8.3/)
  219 FORMAT(3X,F5.0,F7.2,F15.4,10F9.3,I8)
 2219 FORMAT(3X,F5.0,F7.2,F15.4,13F9.3,I8)                              REL.18
  221 FORMAT(4X,'rms error:',16X,5F9.3,9X,3F9.3)
 2221 FORMAT(4X,'rms error:',16X,7F9.3,9X,4F9.3)                        REL.18
  222 FORMAT('  Mean-standard:',14X,5F9.3,9X,3F9.3)
 2222 FORMAT('  Mean-standard:',14X,7F9.3,9X,4F9.3)                     REL.18
  223 FORMAT(5X,'Dead-time information:'//
     1 5X,'DTK = ',1PD10.3,5X,'DTC = ',1PD10.3,5X,'TINT = ',0PF4.0//
     2 5X,'DTK... dead-time coeffient specified on input,'/
     3 5X,'DTC... dead-time coeficient used in calculations'//
     4 5X,'If integration time TINT is not specified (TINT=0), DTC=DTK'/
     5 5X,'(given in units of integration time used) is applied'/)
  224 FORMAT(5X,'and the higher terms of nightly transformation'/       REL.14
     1       7X,'G(9) through G(28) (mag per day):'/5(5X,4G15.5/))      REL.14
  225 FORMAT(/1X,'Following types of objects were re-defined:'//
     *       2X,3HNo.,4X,'Star name',5X,2HHD,4X,'Type'/)                REL.17
  226 FORMAT(5X,'The colour coefficients H'/
     1       14X,3HB-V,7X,3HU-B,5X,'(B-V)^2',3X,'(B-V)^3',5X,
     2       4H  X /6X,2HV:,6F10.5/
     3       6X,2HB:,6F10.5/6X,2HU:,6F10.5/6X,2HW:,6F10.5/)
 2226 FORMAT(5X,'The colour coefficients H'/                            REL.18
     1       14X,3HB-V,7X,3HV-R,5X,'(B-V)^2',3X,'(B-V)^3',5X,           REL.18
     2       4H  X /6X,2HV:,6F10.5/                                     REL.18
     3       6X,2HB:,6F10.5/6X,2HU:,6F10.5/6X,2HW:,6F10.5/)             REL.18
  227 FORMAT(5X,'The colour coefficients H(1) to H(24)')
  228 FORMAT(30X,'The standard stars used'//29X,                        REL.18
     1       'Computed',10X,'Computed-standard'//11X,'Star',            REL.18
     2       2X,'Local time',2X,3Hb-y,3X,3Hu-b,4X,                      REL.18
     3       2HDV,4X,2HDb,4X,2HDu,4X,2HDv,1X,'D(b-y)',1X,               REL.18
     4       'D(u-b)',2X,1HX/19X,1Hh,3X,1Hm)                            REL.18
 2228 FORMAT(30X,'The standard stars used'//29X,                        REL.18
     1       'Computed',10X,'Computed-standard'//11X,'Star',            REL.18
     2       2X,'Local time',2X,3HB-V,3X,3HU-B,4X,                      REL.18
     3       2HDV,4X,2HDB,4X,2HDU,4X,2HDR,1X,'D(B-V)',1X,               REL.18
     4       'D(U-B)',2X,1HX/19X,1Hh,3X,1Hm)                            REL.18
  229 FORMAT (/40X,4Hrms:,6F6.2/)
  230 FORMAT(1X,A2,1X,3A4,F4.0,10F6.2)
  231 FORMAT(5X,'Adjusted zero points:',F12.5,2F38.5/)
  232 FORMAT(80(1H-)/5X,'High voltage',I6,2H V,5X,
     1       'Non-linearity coefficient',F11.8/80(1H-)/)
  233 FORMAT(30X,'The standard stars used'//29X,
     1       'Computed',10X,'Computed-standard'//11X,'Star',
     2       2X,'Local time',2X,1HV,5X,
     3       3HB-V,3X,3HU-B,4X,2HDV,4X,2HDB,4X,2HDU,1X,'D(B-V)',1X,
     4       'D(U-B)',2X,1HX/19X,1Hh,3X,1Hm)
 2233 FORMAT(30X,'The standard stars used'//29X,                        REL.18
     1       'Computed',10X,'Computed-standard'//11X,'Star',            REL.18
     2       2X,'Local time',2X,1HV,5X,                                 REL.18
     3       3HB-V,3X,3HV-R,4X,2HDV,4X,2HDB,4X,2HDR,1X,'D(B-V)',1X,     REL.18
     4       'D(V-R)',2X,1HX/19X,1Hh,3X,1Hm)
  234 FORMAT(/34X,4Hrms:,6F6.2/)
  235 FORMAT(I7,F11.4,I10,I8,3F7.3,F6.3,F7.3,I7)                        REL.17
 2235 FORMAT(I7,F11.4,I10,I8,4F7.3,F6.3,F7.3,I7)                        REL.17
  236 FORMAT(' uvby TABLE'/)
C
  300 FORMAT(57(2H ?))
  301 FORMAT(5X,'Error  1',3X,I4,' gains are requested, which is',
     1      ' more than the allowed maximum 32')
  302 FORMAT(5X,'Error  3',3X,
     *       'No comparison-star observation available')
  303 FORMAT(5X,'Error  2',3X,
     *       'Table of stars contains objects with running numbers',
     *       ' higher than the allowed maximum of',I4)
C
  401 FORMAT(10A4)
C
C$LARGE: AEQ,DEQ,A,D,EQ,HJD,S,V,TT,VV,NK,NKK,C,NH,HD,NT,NCOMP,HVZ        REL.15
C
      CHARACTER*1 NULA(2),DULA(80)                                      REL.14.1
      CHARACTER*12 IN1,IN2,IN3,OUT,OUT1,OUT2,OUT3
      INTEGER*2 IS,IST(2),JKS(3),JES(4)
      INTEGER*2 KTE(5),MES(12),NCOMP(100000),J6K(4),NT                  REL.18
      INTEGER*4 HD,KOBS3(3)
      REAL*4 ADEL(2),VJH(5),VST(6),HVZ(2000,3),VD(100000,4),O7,O8,O9    REL.18
C
      DIMENSION  RMD(8),AEQ(2000),DEQ(2000),A(2000),D(2000),EQ(2000),
     1          TEX(10),POM(3),HJD(2000),RMS(4),RM(4),H(24),HH(24),
     2          OBS(20),CP(20),DEL(20),SIR(20),ASIR(2),RME(6),PM(4),
     3          FC(4),VEM(5),B(30),PRM(7),RV(7),RB(7),RU(7),RW(7),      REL.18
     4          AEV(77),AEB(77),AEU(77),AEW(77),
     5          ACV(42),ACB(42),ACU(42),ACW(42),BS(77),
     6          TX(2),TQ(2),X(6),Y(6),Z(6),ZW(6),DM(8),DEM(4),          REL.14
     7          HHH(6),VX(5),G1B(4)
C
      COMMON /KLICE/
     *K1K,K2K,K3K,K4K,K5K,K6K,K7K,K8K,K9K,K10K,K11K,K12K,K22K
C
      COMMON /DATA/ STRED,U(32),UI(32),DIG,VEX(4),                      REL.18
     *   S(100000,4),V(100000,4),PAS,TT(100000,4),VV(100000,4),         REL.18
     *   C(4,2000),E(12),G(28),VJ(4),BR(6),AVE,                         REL.18
     *   EXT(4),NM(4),NC,NS,NK(100000,4),NKK(100000,4),NH(2000,4),      REL.18
     *   NMIN,NMAX,NDIG,NKAL,HD(2000),NT(2000)                          REL.18
      COMMON /WECKA/ W1,W2,W3,W4,W5,W6,W7,W8,W9,W10                     REL.14.1
      COMMON /TIME/ GEO,DAT,SS,CS,DELKA,SE,CE,DSUN,HEL,
     *              HCAS,UHEL,AIR
      COMMON /DTC/ DTC,HNL,L123
C
C
      DIMENSION HV(6),HB(6),HU(6),HW(6),G0(4),G1(4),GT(4),GT2(4),       REL.14
     *          GT3(4),GT4(4),GT5(4)                                    REL.14
      DIMENSION HVP(5),HBP(5),HUP(5),HWP(5)
      EQUIVALENCE (HV(1),HVP(1),H(1)),(HB(1),HBP(1),H(7)),
     1            (HU(1),HUP(1),H(13)),(HW(1),HWP(1),H(19)),
     1            (G0(1),G(1)),(G1(1),G(5)),(GT(1),G(9)),
     2            (GT2(1),G(13)),(GT3(1),G(17)),                        REL.14
     2            (GT4(1),G(21)),(GT5(1),G(25)),                        REL.14
     3            (POM(1),PM(1)),(VJH(1),VST(1)),(DEM(1),DM(3))         REL.14
C
C
C     INITIALIZATION OF PARAMETERS AND DATA FIELDS
C
C         Note that built-in correction of La Silla local time          REL.16.2
C         UT=LOCAL+5 is only valid from April to October, it must       REL.16.2
C         be set to 4 hours for observations from other months          REL.16.2
C
      DATA OBS/8H  Hvar  ,8H  Brno  ,8HSk.Pleso,8HOndrejov,8H Lowell ,
     1         8HKryoneri,8HMcDonald,8HXingLong,8HSarajevo,8HKPNO-0.4,
     2         8HSAAO-0.5,8HLa Silla,8HMt.Kobau,8HHawaii  ,8HPhoen-10,
     3         8HFairborn,8H APT-Van,8HSt.Lesna,8HAbastum.,8HToronto /
      DATA CP/-1D0,-1D0,-1D0,-1D0,7D0,-2D0,7D0,-8D0,-1D0,7D0,
     1        -2D0,5D0,8D0,10D0,7D0,7D0,7D0,-1D0,-2D0,5D0/
      DATA DEL/ 4.568055D-2, 4.607870D-2, 5.623611D-2, 4.106597D-2,
     1         -3.102431D-1,   6.2847D-2,-2.889491D-1,    3.266D-1,
     2           5.12298D-2,-3.099861D-1, 5.781100D-2,-1.964873935D-1,  REL.16.2
     3          -3.31944D-1,-4.318657D-1,-3.079923D-1,-3.074853D-1,
     4         -3.079923D-1, 5.636420D-2,   1.1875D-1,-2.217593D-1/
      DATA SIR/7.53982D-1,8.587747D-1,8.584984D-1,8.711035D-1,
     1         6.145061D-1,6.57407D-1,5.3532157D-1,7.0499608D-1,
     2         7.651951866D-1,5.5777814D-1,-0.5651085226,-0.5105778191, REL.16.2
     3         8.57248D-1,3.46030916D-1,5.5298818D-1,0.5478006746,
     4         5.5298818D-1,8.5787781D-1,7.28674962D-1,7.62127D-1/
      DATA ADEL/4Heast,4Hwest/
      DATA ASIR/8H  north ,8H  south /
      DATA MES/31,28,31,30,31,30,31,31,30,31,30,31/
      DATA TQ/8H   fixed,8Hcomputed/
      DATA J6K/1,0,2,3/
      DATA JKS/5,3,2/
      DATA IST/2H  ,2HST/
      DATA NULA/1H-,1H0/                                                REL.14.1
C
      PRINT *,'Vstupni soubor ridicich udaju?'
      PRINT *,'Input file with control records?'
      READ(*,'(A)') IN1
      OPEN(3,FILE=IN1,STATUS='OLD')
      READ(3,107) NFIL1,NFIL2,NFIL3
      NFIL=NFIL1+NFIL2
      READ(3,'(A)') IN2
      OPEN(11,FILE=IN2,STATUS='OLD')
      READ(3,'(A)') IN3
      OPEN(12,FILE=IN3,STATUS='OLD')
      READ(3,'(A)') OUT
      OPEN(9,FILE=OUT,STATUS='NEW')
      IF(NFIL1.EQ.0) GO TO 1009
      READ(3,'(A)') OUT1
      OPEN(1,FILE=OUT1,FORM='FORMATTED',STATUS='NEW')                   REL.17
 1009 IF(NFIL2.EQ.0) GO TO 99
      READ(3,'(A)') OUT2
      OPEN(2,FILE=OUT2,FORM='FORMATTED',STATUS='NEW')                   REL.17
   99 IF(NFIL3.EQ.0) GO TO 1010
      READ(3,'(A)') OUT3
      OPEN(4,FILE=OUT3,STATUS='NEW')
 1010 NS=0
      NC=4
      NZAH=0                                                            REL.14
      NZAM=0
      NKAL=32
      KL2=2
      K11K=3
      K12K=0
      DO 11 J=1,NO
   11 HD(J)=0
      DO 87 J=1,24
   87 HH(J)=1D0
      CALL NUL(24,H)
      DTC=0D0
      G1(1)=0.25D0
      G1(2)=0.40D0
      G1(3)=0.70D0
      G1(4)=0.50D0
      U(1)=10D0
C
C
C     RESTART AFTER COLOUR SYSTEM CONVERGED
C
    6 L123=0
      ITER=0
      CALL NUL(NC,RM)
C
C     RESTART OF COLOUR SYSTEM ITERATION
C
    5 CALL NUL(42,ACV)
      CALL NUL(42,ACB)
      CALL NUL(42,ACU)
      IF(NC.GT.3) CALL NUL(42,ACW)
      CALL NUL(NC,RMS)
      CALL MAG(1,J,Q,Q,Q,Q,H)
      NUC=0
      KTAB=0                                                            REL.13
C
C     START OF A NEW NIGHT OF OBSERVATIONS
C     INPUT OF KEYS, DAY OF OBSERVATION AND AUXILIAR PARAMETERS
C
    1 READ(3,101,END=2) K1K,K2K,K3K,K4K,K5K,K6K,K7K,K8K,K9K,K10K,
     1                  KL11,KL12,KOBS3,KTE
      KOBS=1000000*KOBS3(1)+1000*KOBS3(2)+KOBS3(3)
      IF(K1K.LT.0) GO TO 2
C     !!! bacha, Harmance !!!                                           REL.14
      MSYS=3                                                            REL.18
      K11T=KL11                                                         REL.14
      IF(K2K.GT.0) NZAM=0                                               REL.14
      IF(NZAM.NE.0.OR.(KL11.EQ.0.AND.KL12.EQ.0)) GO TO 10
      NZAM=1
      KEY11=KL11/10                                                     REL.14
      KL11=MOD(KL11,10)                                                 REL.14
      K11K=KL11
      K12K=MOD(KL12,10)
      K=KL12-K12K
      K12W=K/10000                                                      REL.13
      K=K-10000*K12W                                                    REL.13
      K12U=K/1000                                                       REL.13
      K=K-1000*K12U                                                     REL.13
      K12B=K/100                                                        REL.13
      K=K-100*K12B                                                      REL.13
      K12V=K/10                                                         REL.13
      K22K=0                                                            REL.13
      IF(K12V.NE.0.AND.K12B.NE.0.AND.K12U.NE.0) K22K=1                  REL.13
   10 KLICEK1=K1K                                                       REL.18
      IF(K1K.LT.99) GO TO 1050                                          REL.18
      MSYS=K1K/100                                                      REL.18
      K1K=MOD(K1K,100)                                                  REL.18
 1050 KL1=K1K/10                                                        REL.18
      K1K=MOD(K1K,10)
      IF(KL1.EQ.0) MDIG=2
      IF(K4K.NE.0) NKAL=IABS(K4K)
      IF(K1K.EQ.5) GO TO 7
      IF(K7K.EQ.-1.AND.L123.EQ.0) L123=2
      IF(K7K.LT.-1.AND.L123.EQ.2) L123=0
      IF(KL1.GT.0) GO TO 1006
      READ(11,102) TEX
      READ(11,103) DEN,ME,LP,NC,NOBS,I,NOBS2,CTIME,VN,TINT,AVE          REL.17
      IF(NOBS.LT.0) NOBS=NOBS2                                          REL.17
      IF(NC.EQ.0) NC=3
      IF(K1K.EQ.3) NC=1                                                 REL.14
      HNL=0D0
      IF(VN.GT.0D0) HNL=1D0/(37.5D0*VN)
 1006 IF(NZAH.EQ.0.AND.K11K.GT.0) WRITE(9,200)                          REL.14
      NZAH=1                                                            REL.14
      IF(L123.GT.0) K7K=-1
      IF(L123.EQ.-1) L123=-2
      IB=2
      IF(NC.EQ.1) IB=1
      IF(NKAL.LE.32) GO TO 12
      WRITE(9,300)
      WRITE(9,301) J
      WRITE(9,300)
      NKAL=32
C
   12 IF(KL1.GT.0) GO TO 14
      IF(I.GT.0) MDIG=I
      IF(NOBS.GT.20) GO TO 13
      IF(NOBS.EQ.0) NOBS=1
      DD=OBS(NOBS)
      PCS=CP(NOBS)
      DELKA=DEL(NOBS)
      SIRKA=SIR(NOBS)
      GO TO 14
C
   13 READ(11,104) Q,Q1,Q2,Q3,Q4,Q5,PCS,DD
      DELKA=(Q+DSIGN(Q1,Q)/60D0+DSIGN(Q2,Q)/3600D0)/24D0
      SIRKA=(Q3+Q4/60D0+Q5/3600D0)*1.745329251D-2
C
C     PRINT OF HEADINGS
C
   14 GEO=GJD(DEN,ME,LP)
      IF(L123.GT.0) GO TO 41
      IF(L123.LT.0.AND.K9K.LT.100) GO TO 41
      Q=DEN+1D0
      J=Q
      IF(J.GT.MES(ME)) Q=1D0
      IF (K11K.GT.0) WRITE(9,208) LP,ME,DEN,Q,TEX
      IF (K11K.GT.0) WRITE(9,209)
     1   KLICEK1,K2K,K3K,K4K,K5K,K6K,K7K,K8K,K9K,K10K,                  REL.14.1
     2   K11T,KL12,KOBS3,KTE                                            REL.14
      J3=1
      J4=1
      IF(DELKA.LT.0D0) J3=2
      IF(SIRKA.LT.0D0) J4=2
      Q1=24D0*DABS(DELKA)
      J1=Q1
      Q=J1
      Q1=60D0*(Q1-Q)
      Q2=DABS(SIRKA)/1.745329251D-2
      J2=Q2
      Q=J2
      Q2=60D0*(Q2-Q)
      IF(K11K.GT.1) WRITE(9,210) DD,J1,Q1,ADEL(J3),J2,Q2,ASIR(J4)
      IF(K11K.GT.1) WRITE(9,211) PCS,CTIME
   41 PAS=PCS+CTIME/60D0
      SS=DSIN(SIRKA)
      CS=DCOS(SIRKA)
      K1K=MOD(K1K,10)
C
C     INPUT OF TABLE OF OBJECTS FOR NON-ZERO VALUES OF K8K
C                               OF ALREADY ENTERED TABLE
C     NEGATIVE VALUES OF K8K SUPRESS THE PRINT OF THE TABLE ON OUTPUT
C     K8K=1: NEW TABLE   K8K=2: CHANGES AND/OR EXPANSION
C
      J1=K8K
      K8K=IABS(K8K)
      IF(K8K.LT.10) NO=999                                              REL.15
      IF(K8K.GT.10) NO=2000                                             REL.15
      IF(K8K.LT.10) K8=22                                               REL.15
      IF(K8K.GT.10) K8=23                                               REL.15
      IF(K8K.EQ.0) GO TO 20
      IF(K8K.GT.1.OR.KTAB.EQ.0) GO TO 1034                              REL.13
      READ(3,'(A)') IN3                                                 REL.13
      OPEN(12,FILE=IN3,STATUS='OLD')                                    REL.13
 1034 L=0                                                               REL.13
      INX=0
      KTAB=1                                                            REL.13
      IF(K8K.EQ.1) NS=0
      IF(L123.EQ.0.AND.J1.GT.0.AND.K11K.GT.2) INX=1
      IF(INX.NE.0.AND.NC.LT.4.AND.MSYS.EQ.3) WRITE(9,212)               REL.18
      IF(INX.NE.0.AND.NC.EQ.4.AND.MSYS.EQ.3) WRITE(9,2212)              REL.18
      IF(INX.NE.0.AND.NC.EQ.4.AND.MSYS.EQ.1) WRITE(9,3212)              REL.18
      IF(INX.NE.0.AND.NC.EQ.3.AND.MSYS.EQ.1) WRITE(9,4212)              REL.18
   16 ZNAM=1D0                                                          REL.14.1
      IF(K8K.NE.1.AND.K8K.NE.11) GO TO 1035                             REL.15
      READ(12,110,END=71) DULA                                          REL.14.1
      IF(DULA(K8).EQ.NULA(1).AND.DULA(K8+1).EQ.NULA(2)) ZNAM=-1D0       REL.15
      BACKSPACE 12                                                      REL.14.1
      IF(K8K.LT.10)                                                     REL.15
     *READ(12,109,END=71) L,J,Q,Q1,Q2,Q3,Q4,Q5,Q6,PM,K,O7,O8,O9         REL.15
      IF(K8K.GT.10)                                                     REL.15
     *READ(12,2109,END=71) L,J,Q,Q1,Q2,Q3,Q4,Q5,Q6,PM,K,O7,O8,O9        REL.15
      GO TO 1036                                                        REL.14.1
 1035 READ(3,110,END=71) DULA                                           REL.14.1
      IF(DULA(K8).EQ.NULA(1).AND.DULA(K8+1).EQ.NULA(2)) ZNAM=-1D0       REL.15
      BACKSPACE 3                                                       REL.14.1
      IF(K8K.LT.10)                                                     REL.15
     *READ(3,109,END=71) L,J,Q,Q1,Q2,Q3,Q4,Q5,Q6,PM,K,O7,O8,O9          REL.15
      IF(K8K.GT.10)                                                     REL.15
     *READ(3,2109,END=71) L,J,Q,Q1,Q2,Q3,Q4,Q5,Q6,PM,K,O7,O8,O9         REL.15
 1036 IF(L.EQ.0) GO TO 71                                               REL.13
      IF(L.LE.NO) GO TO 17
      JER=1
      GO TO 16
   17 IF(L.EQ.0) GO TO 71
      IF(L.GT.NS) NS=L
      M=Q
      IF(INX.NE.0.AND.K8K.LT.10) WRITE(9,2201) (DULA(III),III=1,79)     REL.15
      IF(INX.NE.0.AND.K8K.GT.10) WRITE(9,22201) (DULA(III),III=1,80)    REL.15
      NT(L)=J
      HVZ(L,1)=O7
      HVZ(L,2)=O8
      HVZ(L,3)=O9
      HD(L)=K
      EQ(L)=Q-1900D0
      AEQ(L)=2.617993900D-1*(Q1+Q2/60D0+Q3/3600D0)
      DEQ(L)=1.745329251D-2*(Q4+DSIGN(Q5,Q4)/60D0+DSIGN(Q6,Q4)/3600D0)
      DEQ(L)=DEQ(L)*ZNAM                                                REL.14.1
      C(1,L)=POM(1)
      Q7=POM(1)+POM(2)
      C(2,L)=Q7
      C(3,L)=Q7+POM(3)
      IF(MSYS.EQ.1.AND.NC.EQ.3) C(3,L)=POM(1)-POM(3)                    REL.18
      IF(NC.EQ.4) C(4,L)=C(MSYS,L)-PM(4)                                REL.18
      GO TO 16
C
   71 REWIND 12
      IF(JER.NE.1) GO TO 20
      WRITE(9,300)
      WRITE(9,303) NO
      WRITE(9,300)
      JER=0
C
C     EQUATOREAL COORDINATES OF THE DAY OF OBSERVATION
C
   20 DAT=(GEO-2415020.3135D0)/365.24219D0
      DO 19 J=1,NS
      IF(HD(J).LE.0) GO TO 19
      CALL RADEC(A(J),D(J),AEQ(J),DEQ(J),DAT,EQ(J))
   19 CONTINUE
C
C     INPUT OF COLOUR, EXTINCTION AND OTHER COEFFICIENTS
C
      IF(K2K.GT.99) K2K=5
      IF(L123.EQ.0.OR.L123.EQ.2) GO TO 27
      IF(K2K.EQ.0) GO TO 28
      READ(3,106) Q,Q,Q,Q,Q,DTK
      READ(3,106) Q
      READ(3,106) Q
      IF(NC.EQ.4) READ(3,106) Q
      GO TO 28
   27 IF(K2K.EQ.0) GO TO 28
      READ(3,106) HVP,DTK
      READ(3,106) HBP
      READ(3,106) HUP
      IF(NC.EQ.4) READ(3,106) HWP
      DO 1011 J=1,4
      IF(HVP(J).NE.0D0) GO TO 1012
      IF(HBP(J).NE.0D0) GO TO 1012
      IF(HUP(J).NE.0D0) GO TO 1012
      IF(HWP(J).NE.0D0) GO TO 1012
 1011 CONTINUE
 1012 CALL MAG(1,J,Q,Q,Q,Q,H)
   28 IF(K3K.NE.0) READ(3,106) G1
      IF(K4K.EQ.0) GO TO 1007
      READ(3,106) (U(J),J=1,NKAL)
      DO 1008 J=1,NKAL
 1008 UI(J)=10D0**(-4D-1*U(J))
 1007 IF(DTK.NE.0D0) MDIG=9
      DIG=10D0**(-MDIG)
      NDIG=10**MDIG
      DTC=DTK
      IF(TINT.NE.0D0) DTC=DTK/TINT
      IF(L123.LT.0.AND.K9K.GE.100) GO TO 72
      IF(L123.NE.0) GO TO 78
      IF(K11K.GT.1.AND.MSYS.EQ.3) WRITE(9,226) H                        REL.18
      IF(K11K.GT.1.AND.MSYS.EQ.1.AND.NC.EQ.3) WRITE(9,2226) H           REL.18
      IF(K11K.GT.1.AND.MSYS.EQ.1.AND.NC.EQ.4) WRITE(9,226) H            REL.18
   72 IF(DTK.EQ.0D0) GO TO 8
      IF(K11K.GT.1) WRITE(9,223) DTK,DTC,TINT
      GO TO 78
    8 IF(K11K.LE.1) GO TO 78
      WRITE(9,213)
      WRITE(9,106) (U(J),J=1,NKAL)
      JVN=VN
      WRITE(9,232) JVN,HNL
   78 IF(K10K.EQ.0) GO TO 42
      IF(L123.EQ.0.AND.K11K.GT.1) WRITE(9,225)
   73 READ(3,101) J,K
      IF(J.EQ.0) GO TO 42
      NT(J)=K
      M=EQ(J)+1900D0
      IF(L123.EQ.0.AND.K11K.GT.1)
     1   WRITE(9,201) J,HVZ(J,1),HVZ(J,2),HVZ(J,3),HD(J),K
      GO TO 73
C
C
C     INPUT OF OBSERVATIONS, COMPUTING MAGNITUDES
C
   42 CALL DATABC
      IF(L123.GT.0.AND.K9K.LT.100) GO TO 1
      IF(L123.LT.0.AND.K9K.LT.100.AND.NFIL.EQ.0) GO TO 1
C
C
C     HELIOCENTRIC CORRECTION OF TIME FOR STARS IN THE TABLE
C
      Q=STRED                                                           REL.14
      CALL SUN(Q)                                                       REL.14
      DO 21 J=NMIN,NMAX
      K=NH(J,1)+NH(J,2)+NH(J,3)
      IF(K.LE.0) GO TO 21
      IF(HD(J).GT.0) HJD(J)=HK(A(J),D(J))
   21 CONTINUE
C
C
C     DETERMINATION OF THE EXTINCTION COEFFICIENTS FOR A GIVEN NIGHT
C
      KL5=IABS(K5K)
      IF(KL5.EQ.4) KL5=1                                                REL.14.1
      KP6=K6K/100                                                       REL.14
      KL6=MOD(K6K-100*KP6,10)                                           REL.14
      KL16=(K6K-KL6)/10
      KLEX=0
      DO 1033 J=1,NC
 1033 G1B(J)=0D0
  100 CALL NUL(77,AEV)                                                  REL.14
      CALL NUL(77,AEB)                                                  REL.14
      CALL NUL(77,AEU)                                                  REL.14
      IF(NC.EQ.4) CALL NUL(77,AEW)                                      REL.14
      CALL NUL(4,G0)
      CALL NUL(20,GT)                                                   REL.14
      CALL NUL(6,RME)
      IF(NC.LT.4) CALL NUL(7,RW)                                        REL.14
      IF(NC.LT.3) CALL NUL(7,RU)                                        REL.14
      IF(NC.LT.2) CALL NUL(7,RB)                                        REL.14
      NEX=0
      K=NM(1)
C
      DO 3 J=1,K
      I=NK(J,1)
      IF(NT(I).LT.4) GO TO 3
      NEX=NEX+1
      Q1=A(I)
      Q2=D(I)
      CALL XYZF(I,J,KL5,Q1,Q2,H,X,Y,Z,ZW,FC)
C                                                                       REL.14
C     K6K=0                                                             REL.14
C                                                                       REL.14
      IF(K6K.NE.0) GO TO 49                                             REL.14
      CALL SUMA(1,2,AEV,X,FC(1))                                        REL.14
      IF(NC.GT.1) CALL SUMA(1,2,AEB,Y,FC(2))                            REL.14
      IF(NC.GT.2) CALL SUMA(1,2,AEU,Z,FC(3))                            REL.14
      IF(NC.EQ.4) CALL SUMA(1,2,AEW,ZW,FC(4))                           REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
C     K6K=1                                                             REL.14
C                                                                       REL.14
   49 IF(K6K.NE.1) GO TO 86                                             REL.14
      G(1)=G(1)+FC(1)-G1(1)*X(1)                                        REL.14
      IF(NC.GT.1) G(2)=G(2)+FC(2)-G1(2)*Y(1)                            REL.14
      IF(NC.GT.2) G(3)=G(3)+FC(3)-G1(3)*Z(1)                            REL.14
      IF(NC.GT.3) G(4)=G(4)+FC(4)-G1(4)*ZW(1)                           REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
C     K6K=10                                                            REL.14
C                                                                       REL.14
   86 IF(K6K.NE.10) GO TO 51                                            REL.14
      CALL SUMA(2,3,AEV,X,FC(1))                                        REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
C     K6K=11                                                            REL.14
C                                                                       REL.14
   51 IF(K6K.NE.11) GO TO 1043                                          REL.14
      FC(1)=FC(1)-G1(1)*X(1)                                            REL.14
      X(1)=X(2)                                                         REL.14
      CALL SUMA(1,2,AEV,X,FC(1))                                        REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
C     K6K=20                                                            REL.14
C                                                                       REL.14
 1043 IF(K6K.NE.20) GO TO 1046                                          REL.14
      CALL SUMA(3,4,AEV,X,FC(1))                                        REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
C     K6K=21                                                            REL.14
C                                                                       REL.14
 1046 IF(K6K.NE.21) GO TO 52                                            REL.14
      FC(1)=FC(1)-G1(1)*X(1)                                            REL.14
      X(1)=X(2)                                                         REL.14
      X(2)=X(2)*X(2)                                                    REL.14
      CALL SUMA(2,3,AEV,X,FC(1))                                        REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
   52 IF(K6K.NE.100) GO TO 53                                           REL.14
C                                                                       REL.14
C     K6K=100                                                           REL.14
C                                                                       REL.14
      CALL SUMA(2,3,AEV,X,FC(1))                                        REL.14
      IF(NC.GT.1) CALL SUMA(2,3,AEB,Y,FC(2))                            REL.14
      IF(NC.GT.2) CALL SUMA(2,3,AEU,Z,FC(3))                            REL.14
      IF(NC.GT.3) CALL SUMA(2,3,AEW,ZW,FC(4))                           REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
   53 IF(K6K.NE.200) GO TO 59                                           REL.14
C                                                                       REL.14
C     K6K=200                                                           REL.14
C                                                                       REL.14
      CALL SUMA(3,4,AEV,X,FC(1))                                        REL.14
      IF(NC.GT.1) CALL SUMA(3,4,AEB,Y,FC(2))                            REL.14
      IF(NC.GT.2) CALL SUMA(3,4,AEU,Z,FC(3))                            REL.14
      IF(NC.GT.3) CALL SUMA(3,4,AEW,ZW,FC(4))                           REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
   59 IF(K6K.NE.300) GO TO 74                                           REL.14
C                                                                       REL.14
C     K6K=300                                                           REL.14
C                                                                       REL.14
      CALL SUMA(4,5,AEV,X,FC(1))                                        REL.14
      IF(NC.GT.1) CALL SUMA(4,5,AEB,Y,FC(2))                            REL.14
      IF(NC.GT.2) CALL SUMA(4,5,AEU,Z,FC(3))                            REL.14
      IF(NC.GT.3) CALL SUMA(4,5,AEW,ZW,FC(4))                           REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
   74 IF(K6K.NE.400) GO TO 75                                           REL.14
C                                                                       REL.14
C     K6K=400                                                           REL.14
C                                                                       REL.14
      CALL SUMA(5,6,AEV,X,FC(1))                                        REL.14
      IF(NC.GT.1) CALL SUMA(5,6,AEB,Y,FC(2))                            REL.14
      IF(NC.GT.2) CALL SUMA(5,6,AEU,Z,FC(3))                            REL.14
      IF(NC.GT.3) CALL SUMA(5,6,AEW,ZW,FC(4))                           REL.14
      GO TO 3                                                           REL.14
C                                                                       REL.14
C     K6K=500                                                           REL.14
C                                                                       REL.14
   75 CALL SUMA(6,7,AEV,X,FC(1))                                        REL.14
      IF(NC.GT.1) CALL SUMA(6,7,AEB,Y,FC(2))                            REL.14
      IF(NC.GT.2) CALL SUMA(6,7,AEU,Z,FC(3))                            REL.14
      IF(NC.GT.3) CALL SUMA(6,7,AEW,ZW,FC(4))                           REL.14
C                                                                       REL.14
    3 CONTINUE                                                          REL.14
C                                                                       REL.14
      IF(NEX.EQ.0) GO TO 54                                             REL.14
C                                                                       REL.14
C     K6K=0                                                             REL.14
C                                                                       REL.14
      IF(K6K.NE.0) GO TO 93                                             REL.14
      K=2                                                               REL.14
      CALL RES(K,AEV,BS,RV)                                             REL.14
      IF(NC.GT.1) CALL RES(K,AEB,BS,RB)                                 REL.14
      IF(NC.GT.2) CALL RES(K,AEU,BS,RU)                                 REL.14
      IF(NC.GT.3) CALL RES(K,AEW,BS,RW)                                 REL.14
      G(1)=RV(2)                                                        REL.14
      IF(NC.GT.1) G(2)=RB(2)                                            REL.14
      IF(NC.GT.2) G(3)=RU(2)                                            REL.14
      IF(NC.GT.3) G(4)=RW(2)                                            REL.14
      G(5)=RV(1)                                                        REL.14
      IF(NC.GT.1) G(6)=RB(1)                                            REL.14
      IF(NC.GT.2) G(7)=RU(1)                                            REL.14
      IF(NC.GT.3) G(8)=RW(1)                                            REL.14
      GO TO 54                                                          REL.14
C                                                                       REL.14
C     K6K=1                                                             REL.14
C                                                                       REL.14
C   93 IF(KL6.EQ.0) GO TO 85                                            REL.14
   93 IF(K6K.NE.1) GO TO 34                                             REL.14
      Q=NEX                                                             REL.14
      G(1)=G(1)/Q                                                       REL.14
      IF(NC.GT.1) G(2)=G(2)/Q                                           REL.14
      IF(NC.GT.2) G(3)=G(3)/Q                                           REL.14
      IF(NC.EQ.4) G(4)=G(4)/Q                                           REL.14
      GO TO 54                                                          REL.14
C                                                                       REL.14
C     K6K=11                                                            REL.14
C                                                                       REL.14
   34 IF(K6K.NE.11) GO TO 1040                                          REL.14
      CALL RES(2,AEV,BS,RV)                                             REL.14
      G(9)=RV(1)                                                        REL.14
      G(1)=RV(2)                                                        REL.14
      IF(NC.EQ.1) GO TO 54                                              REL.14
      G(10)=G(9)                                                        REL.14
      IF(NC.GT.2) G(11)=G(9)                                            REL.14
      IF(NC.GT.3) G(12)=G(9)                                            REL.14
      K=NM(1)                                                           REL.14
      DO 1041 J=1,K                                                     REL.14
      I=NK(J,1)                                                         REL.14
      IF(NT(I).LT.4) GO TO 1041                                         REL.14
      Q1=A(I)                                                           REL.14
      Q2=D(I)                                                           REL.14
      CALL XYZF(I,J,KL5,Q1,Q2,H,X,Y,Z,ZW,FC)                            REL.14
      G(2)=G(2)+FC(2)-G1(2)*Y(1)-G(10)*Y(2)                             REL.14
      IF(NC.GT.2) G(3)=G(3)+FC(3)-G1(3)*Z(1)-G(11)*Z(2)                 REL.14
      IF(NC.GT.3) G(4)=G(4)+FC(4)-G1(4)*ZW(1)-G(12)*ZW(2)               REL.14
 1041 CONTINUE                                                          REL.14
      Q=NEX                                                             REL.14
      G(2)=G(2)/Q                                                       REL.14
      IF(NC.GT.2) G(3)=G(3)/Q                                           REL.14
      IF(NC.GT.3) G(4)=G(4)/Q                                           REL.14
      GO TO 54                                                          REL.14
C                                                                       REL.14
C     K6K=10                                                            REL.14
C                                                                       REL.14
 1040 IF(K6K.NE.10) GO TO 1045                                          REL.14
      CALL RES(3,AEV,BS,RV)                                             REL.14
      G(5)=RV(1)                                                        REL.14
      G(9)=RV(2)                                                        REL.14
      G(1)=RV(3)                                                        REL.14
      IF(NC.EQ.1) GO TO 54                                              REL.14
      G(10)=G(9)                                                        REL.14
      IF(NC.GT.2) G(11)=G(9)                                            REL.14
      IF(NC.GT.3) G(12)=G(9)                                            REL.14
      K=NM(1)                                                           REL.14
      DO 1042 J=1,K                                                     REL.14
      I=NK(J,1)                                                         REL.14
      IF(NT(I).LT.4) GO TO 1042                                         REL.14
      Q1=A(I)                                                           REL.14
      Q2=D(I)                                                           REL.14
      CALL XYZF(I,J,KL5,Q1,Q2,H,X,Y,Z,ZW,FC)                            REL.14
      FC(2)=FC(2)-G(10)*Y(2)                                            REL.14
      IF(NC.GT.2) FC(3)=FC(3)-G(11)*Z(2)                                REL.14
      IF(NC.GT.3) FC(4)=FC(4)-G(12)*ZW(2)                               REL.14
      CALL SUMA(1,2,AEB,Y,FC(2))                                        REL.14
      IF(NC.GT.2) CALL SUMA(1,2,AEU,Z,FC(3))                            REL.14
      IF(NC.GT.3) CALL SUMA(1,2,AEW,ZW,FC(4))                           REL.14
 1042 CONTINUE                                                          REL.14
      CALL RES(2,AEB,BS,RB)                                             REL.14
      IF(NC.GT.2) CALL RES(2,AEU,BS,RU)                                 REL.14
      IF(NC.GT.3) CALL RES(2,AEW,BS,RW)                                 REL.14
      G1(2)=RB(1)                                                       REL.14
      IF(NC.GT.2) G1(3)=RU(1)                                           REL.14
      IF(NC.GT.3) G1(4)=RW(1)                                           REL.14
      G0(2)=RB(2)                                                       REL.14
      IF(NC.GT.2) G0(3)=RU(2)                                           REL.14
      IF(NC.GT.3) G0(4)=RW(2)                                           REL.14
      GO TO 54                                                          REL.14
C                                                                       REL.14
C     K6K=20                                                            REL.14
C                                                                       REL.14
 1045 IF(K6K.NE.20) GO TO 1047                                          REL.14
      CALL RES(4,AEV,BS,RV)                                             REL.14
      G(5)=RV(1)                                                        REL.14
      G(9)=RV(2)                                                        REL.14
      G(13)=RV(3)                                                       REL.14
      G(1)=RV(4)                                                        REL.14
      IF(NC.EQ.1) GO TO 54                                              REL.14
      G(10)=G(9)                                                        REL.14
      G(14)=G(13)                                                       REL.14
      IF(NC.GT.2) G(11)=G(9)                                            REL.14
      IF(NC.GT.2) G(15)=G(13)                                           REL.14
      IF(NC.GT.3) G(12)=G(9)                                            REL.14
      IF(NC.GT.3) G(16)=G(13)                                           REL.14
      K=NM(1)                                                           REL.14
      DO 1044 J=1,K                                                     REL.14
      I=NK(J,1)                                                         REL.14
      IF(NT(I).LT.4) GO TO 1044                                         REL.14
      Q1=A(I)                                                           REL.14
      Q2=D(I)                                                           REL.14
      CALL XYZF(I,J,KL5,Q1,Q2,H,X,Y,Z,ZW,FC)                            REL.14
      FC(2)=FC(2)-G(10)*Y(2)-G(14)*Y(2)*Y(2)                            REL.14
      IF(NC.GT.2) FC(3)=FC(3)-G(11)*Z(2)-G(15)*Z(2)*Z(2)                REL.14
      IF(NC.GT.3) FC(4)=FC(4)-G(12)*ZW(2)-G(16)*ZW(2)*ZW(2)             REL.14
      CALL SUMA(1,2,AEB,Y,FC(2))                                        REL.14
      IF(NC.GT.2) CALL SUMA(1,2,AEU,Z,FC(3))                            REL.14
      IF(NC.GT.3) CALL SUMA(1,2,AEW,ZW,FC(4))                           REL.14
 1044 CONTINUE                                                          REL.14
      CALL RES(2,AEB,BS,RB)                                             REL.14
      IF(NC.GT.2) CALL RES(2,AEU,BS,RU)                                 REL.14
      IF(NC.GT.3) CALL RES(2,AEW,BS,RW)                                 REL.14
      G1(2)=RB(1)                                                       REL.14
      IF(NC.GT.2) G1(3)=RU(1)                                           REL.14
      IF(NC.GT.3) G1(4)=RW(1)                                           REL.14
      G0(2)=RB(2)                                                       REL.14
      IF(NC.GT.2) G0(2)=RU(3)                                           REL.14
      IF(NC.GT.3) G0(2)=RW(3)                                           REL.14
      GO TO 54                                                          REL.14
C                                                                       REL.14
C     K6K=21                                                            REL.14
C                                                                       REL.14
 1047 IF(K6K.NE.21) GO TO 85                                            REL.14
      CALL RES(3,AEV,BS,RV)                                             REL.14
      G(9)=RV(1)                                                        REL.14
      G(13)=RV(2)                                                       REL.14
      G(1)=RV(3)                                                        REL.14
      IF(NC.EQ.1) GO TO 54                                              REL.14
      G(10)=G(9)                                                        REL.14
      G(14)=G(13)                                                       REL.14
      IF(NC.GT.2) G(11)=G(9)                                            REL.14
      IF(NC.GT.2) G(15)=G(13)                                           REL.14
      IF(NC.GT.3) G(12)=G(9)                                            REL.14
      IF(NC.GT.3) G(16)=G(13)                                           REL.14
      K=NM(1)                                                           REL.14
      DO 1048 J=1,K                                                     REL.14
      I=NK(J,1)                                                         REL.14
      IF(NT(I).LT.4) GO TO 1048                                         REL.14
      Q1=A(I)                                                           REL.14
      Q2=D(I)                                                           REL.14
      CALL XYZF(I,J,KL5,Q1,Q2,H,X,Y,Z,ZW,FC)                            REL.14
      G(2)=G(2)+FC(2)-G1(2)*Y(1)-G(10)*Y(2)-G(14)*Y(2)*Y(2)             REL.14
      IF(NC.GT.2) G(3)=G(3)+FC(3)-G1(3)*Z(1)-G(11)*Z(2)-G(15)*Z(2)*Z(2) REL.14
      IF(NC.GT.3)                                                       REL.14
     * G(4)=G(4)+FC(4)-G1(4)*ZW(1)-G(12)*ZW(2)-G(16)*ZW(2)*ZW(2)        REL.14
 1048 CONTINUE                                                          REL.14
      Q=NEX                                                             REL.14
      G(2)=G(2)/Q                                                       REL.14
      IF(NC.GT.2) G(3)=G(3)/Q                                           REL.14
      IF(NC.GT.3) G(4)=G(4)/Q                                           REL.14
      GO TO 54                                                          REL.14
C                                                                       REL.14
C     K6K=100, 200, 300, 400 & 500                                      REL.14
C                                                                       REL.14
   85 K=2+K6K/100                                                       REL.14
      CALL RES(K,AEV,BS,RV)                                             REL.14
      IF(NC.GT.1) CALL RES(K,AEB,BS,RB)                                 REL.14
      IF(NC.GT.2) CALL RES(K,AEU,BS,RU)                                 REL.14
      IF(NC.GT.3) CALL RES(K,AEW,BS,RW)                                 REL.14
      G1(1)=RV(1)                                                       REL.14
      IF(NC.NE.1) G1(2)=RB(1)                                           REL.14
      IF(NC.GT.2) G1(3)=RU(1)                                           REL.14
      IF(NC.GT.3) G1(4)=RW(1)                                           REL.14
      GT(1)=RV(2)                                                       REL.14
      IF(NC.GT.1) GT(2)=RB(2)                                           REL.14
      IF(NC.GT.2) GT(3)=RU(2)                                           REL.14
      IF(NC.GT.3) GT(4)=RW(2)                                           REL.14
      IF(K.EQ.3) GO TO 77                                               REL.14
      GT2(1)=RV(3)                                                      REL.14
      IF(NC.GT.1) GT2(2)=RB(3)                                          REL.14
      IF(NC.GT.2) GT2(3)=RU(3)                                          REL.14
      IF(NC.GT.3) GT2(4)=RW(3)                                          REL.14
      IF(K.EQ.4) GO TO 77                                               REL.14
      GT3(1)=RV(4)                                                      REL.14
      IF(NC.GT.1) GT3(2)=RB(4)                                          REL.14
      IF(NC.GT.2) GT3(3)=RU(4)                                          REL.14
      IF(NC.GT.3) GT3(4)=RW(4)                                          REL.14
      IF(K.EQ.5) GO TO 77                                               REL.14
      GT4(1)=RV(5)                                                      REL.14
      IF(NC.GT.1) GT4(2)=RB(5)                                          REL.14
      IF(NC.GT.2) GT4(3)=RU(5)                                          REL.14
      IF(NC.GT.3) GT4(4)=RW(5)                                          REL.14
      IF(K.EQ.6) GO TO 77                                               REL.14
      GT5(1)=RV(6)                                                      REL.14
      IF(NC.GT.1) GT5(2)=RB(6)                                          REL.14
      IF(NC.GT.2) GT5(3)=RU(6)                                          REL.14
      IF(NC.GT.3) GT5(4)=RW(6)                                          REL.14
   77 G0(1)=RV(K)                                                       REL.14
      IF(NC.GT.1) G0(2)=RB(K)                                           REL.14
      IF(NC.GT.2) G0(3)=RU(K)                                           REL.14
      IF(NC.GT.3) G0(4)=RW(K)                                           REL.14
      GO TO 54                                                          REL.14
C
C     ITERATING THE LINEAR EXTINCTION COEFFICIENTS                      REL.14
C
   54 IF(KL6.NE.0) GO TO 1031
      IF(DABS((G1(1)-G1B(1))/G1(1)).GT.1.0D-5) KLEX=1
      IF(NC.GT.1.AND.DABS((G1(2)-G1B(2))/G1(2)).GT.1.0D-5) KLEX=1
      IF(NC.GT.2.AND.DABS((G1(3)-G1B(3))/G1(3)).GT.1.0D-5) KLEX=1
      IF(NC.GT.3.AND.DABS((G1(4)-G1B(4))/G1(4)).GT.1.0D-5) KLEX=1
      IF(KLEX.EQ.0) GO TO 1031
      KLEX=0
      DO 1032 J=1,NC
 1032 G1B(J)=G1(J)
      GO TO 100
C
C     RE-CALCULATION OF ZERO-POINT COEFFICIENTS                         REL.14
C     USING OBJECTS OF TYPE 7 TO 9 ONLY                                 REL.14
C
 1031 K=NM(1)
      M=0
      CALL NUL(4,AEV)
      DO 67 J=1,K
      I=NK(J,1)
      IF(NT(I).LT.7) GO TO 67
      M=M+1
      Q1=A(I)
      Q2=D(I)
      CALL  XYZF(I,J,KL5,Q1,Q2,H,X,Y,Z,ZW,FC)
      AEV(1)=AEV(1)+FC(1)-G1(1)*X(1)-GT(1)*X(2)                         REL.14
      IF(K6K.GT.100) AEV(1)=                                            REL.14
     *AEV(1)-GT2(1)*X(3)-GT3(1)*X(4)-GT4(1)*X(5)-GT5(1)*X(6)            REL.14
      IF(K6K.LT.100) AEV(1)=AEV(1)-GT2(1)*X(2)*X(2)                     REL.14
      IF(NC.LT.2) GO TO 67                                              REL.14
      AEV(2)=AEV(2)+FC(2)-G1(2)*Y(1)-GT(2)*Y(2)                         REL.14
      IF(K6K.GT.100) AEV(2)=                                            REL.14
     *AEV(2)-GT2(2)*Y(3)-GT3(2)*Y(4)-GT4(2)*Y(5)-GT5(2)*Y(6)            REL.14
      IF(K6K.LT.100) AEV(2)=AEV(2)-GT2(2)*Y(2)*Y(2)                     REL.14
      IF(NC.LT.3) GO TO 67                                              REL.14
      AEV(3)=AEV(3)+FC(3)-G1(3)*Z(1)-GT(3)*Z(2)                         REL.14
      IF(K6K.GT.100) AEV(3)=                                            REL.14
     *AEV(3)-GT2(3)*Z(3)-GT3(3)*Z(4)-GT4(3)*Z(5)-GT5(3)*Z(6)            REL.14
      IF(K6K.LT.100) AEV(3)=AEV(3)-GT2(3)*Z(2)*Z(2)                     REL.14
      IF(NC.LT.4) GO TO 67                                              REL.14
      AEV(4)=AEV(4)+FC(4)-G1(4)*ZW(1)-GT(4)*ZW(2)                       REL.14
      IF(K6K.GT.100) AEV(4)=AEV(4)-GT2(4)*ZW(3)                         REL.14
     *-GT3(4)*ZW(4)-GT4(4)*ZW(5)-GT5(4)*ZW(6)                           REL.14
      IF(K6K.LT.100) AEV(4)=AEV(4)-GT2(4)*ZW(2)*ZW(2)                   REL.14
   67 CONTINUE
      IF(M.LE.0) GO TO 55
      Q=M
      G(1)=AEV(1)/Q
      IF(NC.GT.1) G(2)=AEV(2)/Q                                         REL.14
      IF(NC.GT.2) G(3)=AEV(3)/Q                                         REL.14
      IF(NC.GT.3) G(4)=AEV(4)/Q                                         REL.14
C
   55 IF(L123.GT.0) GO TO 43
      IF(L123.LT.0.AND.K9K.LT.100) GO TO 43
      TX(1)=TQ(2)
      IF(KL6.EQ.1) TX(1)=TQ(1)
      IF(K11K.EQ.0) GO TO 43
      IF(NC.LT.4.AND.MSYS.EQ.3)                                         REL.18
     *  WRITE(9,203) (G1(J),J=1,3),TX(1),H(5),H(11),H(17),TQ(1)         REL.18
      IF(NC.EQ.3.AND.MSYS.EQ.1)                                         REL.18
     *  WRITE(9,4203) (G1(J),J=1,3),TX(1),H(5),H(11),H(17),TQ(1)        REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.3)                                         REL.18
     *  WRITE(9,2203) G1,TX(1),H(5),H(11),H(17),H(23),TQ(1)             REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.1)                                         REL.18
     *  WRITE(9,3203) G1,TX(1),H(5),H(11),H(17),H(23),TQ(1)             REL.18
      WRITE(9,224) GT,GT2,GT3,GT4,GT5
C
C
C     PRINT OF EXTINCTION-STAR OBSERVATIONS
C
   43 K=NM(1)
      IF(K.LT.1) GO TO 1
      IF(NEX.EQ.0) GO TO 15
      J1=S(1,1)+GEO-2400000D0
      IF (NFIL3.NE.0.AND.KL6.NE.1) WRITE(4,108) J1,G1
      IF(KEY11.GT.0.AND.NEX.EQ.1) WRITE(9,1039)                         REL.16.2
 1039 FORMAT(/' Plot for a single extinction-star',                     REL.16.2
     *' observation suppressed'/)                                       REL.16.2
      IF(KEY11.GT.0.AND.NEX.GT.1) CALL GRAF(0,NC,MSYS,S(J,1),DEM)       REL.18
      IF(L123.LT.0.AND.K9K.LT.100) GO TO 82
      IF(L123.LE.0.AND.K11K.GE.3.AND.K1K.EQ.3) WRITE(9,2114) J1         REL.14
      IF(L123.LE.0.AND.K11K.GE.3.AND.NC.LE.3.AND.K1K.NE.3.AND.MSYS.EQ.3)REL.18
     *      WRITE(9,214) J1
      IF(L123.LE.0.AND.K11K.GE.3.AND.NC.EQ.4.AND.MSYS.EQ.3)             REL.18
     *   WRITE(9,2214) J1                                               REL.18
      IF(L123.LE.0.AND.K11K.GE.3.AND.NC.EQ.4.AND.MSYS.EQ.1)             REL.18
     *   WRITE(9,3214) J1                                               REL.18
      IF(L123.LE.0.AND.K11K.GE.3.AND.NC.EQ.3.AND.MSYS.EQ.1)             REL.18
     *   WRITE(9,4214) J1                                               REL.18
      IF(L123.LE.0.AND.K11K.EQ.2.AND.NC.LE.3.AND.MSYS.EQ.3)             REL.18
     *   WRITE(9,233)                                                   REL.18
      IF(L123.LE.0.AND.K11K.EQ.2.AND.NC.EQ.3.AND.MSYS.EQ.1)             REL.18
     *   WRITE(9,2233)                                                  REL.18
      IF(L123.LE.0.AND.K11K.EQ.2.AND.NC.EQ.4.AND.MSYS.EQ.3)             REL.18
     *   WRITE(9,228)                                                   REL.18
      IF(L123.LE.0.AND.K11K.EQ.2.AND.NC.EQ.4.AND.MSYS.EQ.1)             REL.18
     *   WRITE(9,2228)                                                  REL.18
C

   82 NOEH=0                                                            REL.14
      DO 24 J=1,K
      I=NK(J,1)
      IF(NT(I).LT.4) GO TO 24
      NOEH=NOEH+1                                                       REL.14
      Q1=A(I)
      Q2=D(I)
      Q=S(J,2)+GEO
      Q11=S(J,1)+GEO
      IF(NC.GT.1) GO TO 95
      Q=Q11
      GO TO 96
   95 CALL HMOTA(Q1,Q2,Q)
      AI2=AIR
      IF(KL5.NE.1) GO TO 60
      IF(NC.LT.3) GO TO 96
      CALL HMOTA(Q1,Q2,S(J,3)+GEO)
      AI3=AIR
      IF(NC.LT.4) GO TO 96
      CALL HMOTA(Q1,Q2,S(J,4)+GEO)
      AI4=AIR
   96 CALL HMOTA(Q1,Q2,Q11)
      AI1=AIR
      GO TO 70
   60 AI1=AIR
      AI3=AIR
      AI4=AIR
   70 CALL MAG(0,J,AI1,AI2,AI3,AI4,H)
      Q11=C(1,I)
      Q12=C(2,I)
      Q13=C(3,I)
      Q14=C(4,I)
      DM(3)=VJ(1)-Q11
      IF(K1K.EQ.3) DM(3)=VJ(1)-Q12+Q11                                  REL.14
      DM(4)=VJ(2)-Q12
      DM(5)=VJ(3)-Q13
      DM(6)=VJ(4)-Q14
      DM(7)=DM(4)-DM(3)
      DM(8)=DM(5)-DM(4)
      Q1=DM(3)*DM(3)
      Q2=DM(4)*DM(4)
      Q3=DM(5)*DM(5)
      Q4=DM(6)*DM(6)
      Q9=DM(7)*DM(7)
      Q10=DM(8)*DM(8)
      IF(K9K.LT.100.OR.NT(I).LT.7) GO TO 31
      VEM(1)=Q12-Q11
      VEM(2)=Q13-Q12
      VEM(3)=VEM(1)*VEM(1)
      VEM(4)=VEM(1)*VEM(3)
      Q16=G(6)-G(5)
      IF(K1K.EQ.3) Q16=G(5)                                             REL.14
      Q15=Q16*AI1
      VEM(5)=Q15*(VEM(1)+5D-1*Q15)
      JES(1)=JKS(K12V+1)-K12K
      DO 1013 JN=1,4
 1013 VX(JN)=VEM(JN)
      JN=JES(1)
      JN1=JN+1
      PS=VEX(1)                                                         REL.14
      IF(K1K.NE.3) PS=PS-Q11                                            REL.14
      IF(K12K.NE.0) PS=PS-H(5)*VEM(5)
      IF(K12K.EQ.0) VX(JN)=VEM(5)
      CALL SUMA(JN,JN1,ACV,VX,PS)
C
      Q15=Q16*AI2
      VEM(5)=Q15*(VEM(1)+5D-1*Q15)
      JES(2)=JKS(K12B+1)-K12K
      DO 1014 JN=1,4
 1014 VX(JN)=VEM(JN)
      JN=JES(2)
      JN1=JN+1
      PS=VEX(2)-Q12
      IF(K12K.NE.0) PS=PS-H(11)*VEM(5)
      IF(K12K.EQ.0) VX(JN)=VEM(5)
      CALL SUMA(JN,JN1,ACB,VX,PS)
C
      Q16=G(7)-G(6)
      Q15=AI3*Q16
      VEM(5)=Q15*(VEM(2)+5D-1*Q15)
      JES(3)=JKS(K12U+1)-K12K
      DO 1015 JN=1,4
 1015 VX(JN)=VEM(JN)
      JN=JES(3)
      JN1=JN+1
      PS=VEX(3)-Q13
      IF(K12K.NE.0) PS=PS-H(17)*VEM(5)
      IF(K12K.EQ.0) VX(JN)=VEM(5)
      CALL SUMA(JN,JN1,ACU,VX,PS)
C
      IF(NC.LT.4) GO TO 1001
      Q15=AI4*Q16
      VEM(5)=Q15*(VEM(2)+5D-1*Q15)
      JES(4)=JKS(K12W+1)-K12K
      DO 1030 JN=1,4
 1030 VX(JN)=VEM(JN)
      JN=JES(4)
      JN1=JN+1
      PS=VEX(4)-Q14
      IF(K12K.NE.0) PS=PS-H(23)*VEM(5)
      IF(K12K.EQ.0) VX(JN)=VEM(5)
      CALL SUMA(JN,JN1,ACW,VX,PS)
 1001 NUC=NUC+1
      RMS(1)=RMS(1)+Q1
      RMS(2)=RMS(2)+Q2
      RMS(3)=RMS(3)+Q3
      IF(NC.EQ.4) RMS(4)=RMS(4)+Q4
   31 IF(L123.GT.0) GO TO 24
      RME(1)=RME(1)+Q1
      IF(NC.GT.1) RME(2)=RME(2)+Q2
      IF(NC.GT.2) RME(3)=RME(3)+Q3
      IF(NC.EQ.4) RME(4)=RME(4)+Q4
      IF(NC.GT.1) RME(5)=RME(5)+Q9
      IF(NC.GT.2) RME(6)=RME(6)+Q10
      Q10=24D0*S(J,IB)-PAS
      J1=Q10
      Q9=J1
      Q10=60D0*(Q10-Q9)
      DM(1)=VJ(2)-VJ(1)
      DM(2)=VJ(3)-VJ(2)
      IF(NC.EQ.3.AND.MSYS.EQ.1) DM(2)=VJ(1)-VJ(3)                       REL.18
      IS=IST(1)
      IF(NT(I).GE.7) IS=IST(2)
      Q=0D0                                                             REL.15
      DO 1037 IJ=1,NC                                                   REL.15
 1037 Q=Q+S(J,IJ)                                                       REL.15
      QNC=NC                                                            REL.15
      Q=Q/QNC+GEO                                                       REL.15
      IF(NOEH.EQ.1) JZN=Q                                               REL.14
      Q=Q-JZN                                                           REL.14
      AIR=AI2
      IF(NC.EQ.1) AIR=AI1
      IF(KEY11.GT.0.AND.NEX.GT.1) CALL GRAF(1,NC,MSYS,Q,DEM)            REL.18
      IF(L123.LT.0.AND.K9K.LT.100) GO TO 24
      IF(K11K.GE.3.AND.NC.EQ.4)
     1  WRITE(9,204) IS,HVZ(I,1),HVZ(I,2),HVZ(I,3),Q9,Q10,Q,
     2               VJ,DM,AIR,EXT                                      REL.14
      IF(K11K.GE.3.AND.NC.LT.4.AND.K1K.NE.3)                            REL.14
     *       WRITE(9,204) IS,HVZ(I,1),HVZ(I,2),
     *       HVZ(I,3),Q9,Q10,Q,(VJ(J1),J1=1,3),(DM(J1),J1=1,5),
     *       DM(7),DM(8),AIR,(EXT(J1),J1=1,3)                           REL.14
      IF(K11K.GE.3.AND.K1K.EQ.3) WRITE(9,204) IS,HVZ(I,1),HVZ(I,2),     REL.14
     *       HVZ(I,3),Q9,Q10,Q,VJ(1),DM(3),AIR,EXT(1)                   REL.14
      IF(K11K.EQ.2.AND.NC.LT.4)
     *  WRITE(9,230) IS,HVZ(I,1),HVZ(I,2),HVZ(I,3),Q9,Q10,
     *       VJ(1),(DM(J1),J1=1,5),DM(7),DM(8),AIR
      IF(K11K.EQ.2.AND.NC.EQ.4)
     *WRITE(9,230) IS,HVZ(I,1),HVZ(I,2),HVZ(I,3),Q9,Q10,DM,AIR
   24 CONTINUE
C
   83 IF(L123.GT.0) GO TO 1
      IF(NEX.LE.1.OR.(L123.LT.0.AND.K9K.LT.100)) GO TO 15
      Q=NEX-1
      Q=1D0/Q
      DO 35 J=1,6
   35 RME(J)=DSQRT(Q*RME(J))
      IF(K11K.GE.3.AND.NC.EQ.4) WRITE(9,2218) RME
      IF(K11K.GE.3.AND.NC.LT.4.AND.K1K.NE.3)                            REL.14
     *       WRITE(9,218) (RME(J),J=1,3),RME(5),RME(6)
      IF(K11K.GE.3.AND.K1K.EQ.3)                                        REL.14
     *       WRITE(9,2318) RME(1)                                       REL.14
      IF(K11K.EQ.2.AND.NC.EQ.4) WRITE(9,234) RME
      IF(K11K.EQ.2.AND.NC.LT.4)
     *       WRITE(9,229) (RME(J),J=1,3),RME(5),RME(6)
   15 IF(KEY11.GT.0.AND.NEX.GT.1) CALL GRAF(2,NC,MSYS,S(J,1),DEM)       REL.18
      IF(NFIL.EQ.0.AND.K11K.LT.3) GO TO 1
      IF(L123.LT.0.AND.NFIL.EQ.0) GO TO 1
C
C
C     COMPUTING JOHNSON'S MAGNITUDES FOR TYPE 1-3 OBJECTS
C
      K=NM(1)
      DO 63 I=1,K
      J=NK(I,1)
      IF(NT(J).GT.3) GO TO 63
      Q1=A(J)
      Q2=D(J)
      IF(NC.EQ.1) GO TO 97
      CALL HMOTA(Q1,Q2,S(I,2)+GEO)
      AI2=AIR
      IF(KL5.NE.1) GO TO 68
      CALL HMOTA(Q1,Q2,S(I,3)+GEO)
      AI3=AIR
      IF(NC.LT.4) GO TO 97
      CALL HMOTA(Q1,Q2,S(I,4)+GEO)
      AI4=AIR
   97 CALL HMOTA(Q1,Q2,S(I,1)+GEO)
      AI1=AIR
      GO TO 69
   68 AI1=AIR
      AI3=AIR
      AI4=AIR
   69 CALL MAG(0,I,AI1,AI2,AI3,AI4,H)
   63 CONTINUE
      IF(K1K.EQ.2) GO TO 30
C
C
C     K1K=0: COMPUTING MAGNITUDE DIFFERENCES VAR-COMP
C
      N=NM(1)
      DO 45 J=1,N
   45 NCOMP(J)=0
      CALL INDX(1,J1,J3)
      IF(J1.EQ.1) GO TO 22
      IF(J1.GT.1) GO TO 46
      WRITE(9,302)
      K1K=2
      GO TO 30
   46 K=J1-1
      DO 23 I=1,K
      NCOMP(I)=J3
      DO 23 J=1,NC
   23 VD(I,J)=V(I,J)-V(J1,J)
   22 K=J1+1
      IF(K.GT.N) GO TO 30
      CALL INDX(K,J2,J4)
      IF(J2.LT.0) GO TO 61
      IF(J2.EQ.K) GO TO 9
      L=J2-1
      IF(J3.EQ.J4) GO TO 90
      DO 89 I=K,L
      Q1=S(J1,IB)
      Q2=S(J2,IB)
      M=J3
      M1=J1
      Q3=S(I,IB)
      IF(DABS(Q3-Q1).LE.DABS(Q3-Q2)) GO TO 88
      M=J4
      M1=J2
   88 NCOMP(I)=M
      DO 89 J=1,NC
   89 VD(I,J)=V(I,J)-V(M1,J)
      GO TO 9
   90 DO 32 J=1,NC
      Q1=S(J1,J)
      Q11=V(J1,J)
      Q=(V(J2,J)-Q11)/(S(J2,J)-Q1)
      DO 32 I=K,L
   32 VD(I,J)=V(I,J)-Q*(S(I,J)-Q1)-Q11
      DO 33 I=K,L
   33 NCOMP(I)=J3
    9 J1=J2
      J3=J4
      GO TO 22
   61 DO 62 I=K,N
      NCOMP(I)=J3
      DO 62 J=1,NC
   62 VD(I,J)=V(I,J)-V(J1,J)
C
C
C     PRINT OF MAGNITUDES AND INDICES OF INDIVIDUAL STARS
C
   30 KL9=K9K                                                           REL.14
      IF(K9K.GE.100) KL9=K9K-100                                        REL.14
      K9K=K9K+1000*J6K(KL6+1)+10000*NOBS
      DO 25 I=NMIN,NMAX
      IF(NH(I,1).EQ.0) GO TO 25
      J1=NM(1)
      IF(K11K.GT.2.AND.NC.LT.4.AND.MSYS.EQ.3)                           REL.18
     *   WRITE(9,205) HVZ(I,1),HVZ(I,2),HVZ(I,3),HD(I)
      IF(K11K.GT.2.AND.NC.EQ.3.AND.MSYS.EQ.1)                           REL.18
     *   WRITE(9,3205) HVZ(I,1),HVZ(I,2),HVZ(I,3),HD(I)                 REL.18
      IF(K11K.GT.2.AND.NC.EQ.4.AND.MSYS.EQ.1)                           REL.18
     *   WRITE(9,1205) HVZ(I,1),HVZ(I,2),HVZ(I,3),HD(I)                 REL.18
      IF(K11K.GT.2.AND.NC.EQ.4.AND.MSYS.EQ.3)                           REL.18
     *   WRITE(9,2205) HVZ(I,1),HVZ(I,2),HVZ(I,3),HD(I)
      NEX=0
      NED=0
      CALL NUL(20,B)                                                    REL.18
      CALL NUL(8,RMD)
      DO 26 J=1,J1
      K=NK(J,1)
      IF(K.NE.I) GO TO 26
      NEX=NEX+1
      Q=0D0                                                             REL.15
      DO 1038 IJ=1,NC                                                   REL.15
 1038 Q=Q+S(J,IJ)                                                       REL.15
      QNC=NC                                                            REL.15
      Q=Q/QNC                                                           REL.15
      Q3=24D0*Q-PAS
      L=Q3
      Q8=L
      Q5=60D0*(Q3-Q8)
      CALL HMOTA(A(K),D(K),Q+GEO)
      Q7=Q+HJD(K)
      VJ(1)=V(J,1)
      VJ(2)=V(J,2)
      VJ(3)=V(J,3)
      VJ(4)=V(J,4)
      Q1=VJ(2)-VJ(1)
      Q2=VJ(3)-VJ(2)
      IF(MSYS.EQ.1.AND.NC.EQ.3) Q2=VJ(1)-VJ(3)                          REL.18
      IF(NC.EQ.4) Q3=VJ(MSYS)-VJ(4)                                     REL.18
      DO 56 L=1,4
      M=L+7                                                             REL.18
      QQ=VJ(L)                                                          REL.18
      B(L)=B(L)+QQ                                                      REL.18
      IF(L.GT.NC) GO TO 56
      B(M)=B(M)+QQ*QQ                                                   REL.18
   56 CONTINUE
      B(5)=B(5)+Q1
      B(6)=B(6)+Q2
      B(7)=B(7)+Q3                                                      REL.18
      IF(NC.GT.1) B(12)=B(12)+Q1*Q1                                     REL.18
      IF(NC.GT.2) B(13)=B(13)+Q2*Q2                                     REL.18
      IF(NC.GT.3) B(14)=B(14)+Q3*Q3                                     REL.18
      B(20)=B(20)+Q7                                                    REL.18
      Q111=Q1
      Q222=Q2
      Q333=Q3                                                           REL.18
      KPR=NCOMP(J)
      IF((K1K.EQ.2.OR.KPR.EQ.0).AND.K11K.GT.2.AND.NC.LT.4)
     *         WRITE(9,206) Q8,Q5,Q7,(VJ(L),L=1,3),Q1,Q2,AIR
      IF((K1K.EQ.2.OR.KPR.EQ.0).AND.K11K.GT.2.AND.NC.EQ.4)
     *         WRITE(9,206) Q8,Q5,Q7,VJ,Q1,Q2,Q3,AIR
      IF(NFIL.EQ.0.AND.K11K.LT.3) GO TO 26
C
C     OUTPUT OF DATA FOR ARCHIVES
C
      M=4
      IF(NC.EQ.4) M=5
      HELJD=Q7-2400000D0
      DO 1049 L=1,4                                                     REL.17.1
      IF(VJ(L).GT.99.999D0) VJ(L)=99.999D0                              REL.17.1
 1049 VJH(L)=VJ(L)                                                      REL.17.1
      VJH(M)=AIR
      IF(KL9.LT.10) GO TO 76                                            REL.14
      K=0
      IF(NFIL2.NE.0.AND.NC.LT.4)                                        REL.17
     *   WRITE(2,235) HD(I),HELJD,KOBS,K9K,VJH,K                        REL.17
      IF(NFIL2.NE.0.AND.NC.EQ.4)                                        REL.17
     *   WRITE(2,2235) HD(I),HELJD,KOBS,K9K,VST,K                       REL.17
   76 IF(K1K.EQ.2) GO TO 26                                             REL.14
      IF(NFIL1.EQ.0.AND.K11K.LT.3) GO TO 26
      K=NCOMP(J)
      IF(K.LE.0) GO TO 26
      NED=NED+1
      CALL HMOTA(A(K),D(K),Q+GEO)
      Q1=VD(J,1)
      Q2=VD(J,2)
      Q3=VD(J,3)
      Q4=VD(J,4)
      IF(NC.LT.4) Q4=99.999D0                                           REL.17.1
      IF(NC.LT.3) Q3=99.999D0                                           REL.17.1
      IF(NC.LT.2) Q2=99.999D0                                           REL.17.1
      VJH(1)=Q1
      VJH(2)=Q2
      VJH(3)=Q3
      IF(NC.EQ.4) VJH(4)=Q4
      VJH(M+1)=VJH(M)-AIR
      IF(NFIL1.NE.0.AND.NC.LT.4)                                        REL.17
     *      WRITE(1,235) HD(I),HELJD,KOBS,K9K,VJH,HD(K)                 REL.17
      IF(NFIL1.NE.0.AND.NC.EQ.4)                                        REL.17
     *      WRITE(1,2235) HD(I),HELJD,KOBS,K9K,VST,HD(K)                REL.17
C
C
C     PRINT OF DIFFERENTIAL MAGNITUDES AND INDICES
C
      Q1=Q1+C(1,K)
      Q2=Q2+C(2,K)
      Q3=Q3+C(3,K)                                                      REL.18
      Q4=Q4+C(4,K)                                                      REL.18
      IF(NC.GT.3.AND.MSYS.EQ.3) Q4=Q3-Q4                                REL.18
      IF(NC.GT.3.AND.MSYS.EQ.1) Q4=Q1-Q4                                REL.18
      IF(NC.EQ.4.OR.NC.LT.4.AND.MSYS.EQ.3) Q3=Q3-Q2                     REL.18
      IF(NC.EQ.3.AND.MSYS.EQ.1) Q3=Q1-Q3                                REL.18
      Q2=Q2-Q1
      RMD(1)=RMD(1)+Q1
      IF(NC.GT.1) RMD(2)=RMD(2)+Q2
      IF(NC.GT.2) RMD(3)=RMD(3)+Q3
      IF(NC.GT.3) RMD(4)=RMD(4)+Q4
      RMD(5)=RMD(5)+Q1*Q1
      IF(NC.GT.1) RMD(6)=RMD(6)+Q2*Q2
      IF(NC.GT.2) RMD(7)=RMD(7)+Q3*Q3
      IF(NC.GT.3) RMD(8)=RMD(8)+Q4*Q4
      IF(K11K.GT.2.AND.NC.LT.4) WRITE(9,219) Q8,Q5,Q7,(VJ(J1),J1=1,3),
     *   Q111,Q222,VJH(M),Q1,Q2,Q3,VJH(M+1),HD(K)
      IF(K11K.GT.2.AND.NC.EQ.4) WRITE(9,2219)                           REL.18
     * Q8,Q5,Q7,VJ,Q111,Q222,Q333,VJH(M),Q1,Q2,Q3,Q4,VJH(M+1),HD(K)     REL.18
   26 CONTINUE
C
C
C     COMPUTATION AND PRINT OF MEAN VALUES AND RMS ERRORS
C
      KPR=1
      J=NT(I)
      IF(J.EQ.2.OR.J.EQ.5.OR.J.EQ.8) KPR=0
      IF((K1K.EQ.2.OR.KPR.EQ.0).AND.K11K.GT.2) KPR=2
      Q1=NEX
      Q2=NEX-1
      Q1=1D0/Q1
      DO 57 L=1,7                                                       REL.18
      M=L+7                                                             REL.18
      Q3=B(L)
      Q4=Q1*Q3
      B(L)=Q4
      IF(L.LE.4) PRM(L)=Q4-C(L,I)
      IF(NEX.LT.2) GO TO 66
      Q3=(B(M)-Q1*Q3*Q3)/Q2                                             REL.13.1
      IF(Q3.LE.0D0) GO TO 66
      B(M)=DSQRT(Q3)
      GO TO 57
   66 B(M)=0D0
   57 CONTINUE
      B(20)=B(20)*Q1                                                    REL.18
      PRM(5)=B(5)-C(2,I)+C(1,I)
      PRM(6)=B(6)-C(3,I)+C(2,I)
      IF(NC.EQ.3.AND.MSYS.EQ.1) PRM(6)=B(6)+C(3,I)-C(1,I)               REL.18
      PRM(7)=B(7)-C(MSYS,I)+C(4,I)                                      REL.18
      IF(KPR.EQ.2.AND.NEX.GT.1.AND.NC.LT.4)
     *   WRITE(9,217) B(20),(B(L),L=1,3),B(5),B(6)                      REL.18
      IF(KPR.EQ.2.AND.NEX.GT.1.AND.NC.EQ.4)
     *   WRITE(9,2217) B(20),(B(L),L=1,7)                               REL.18
      IF(NED.LE.0) GO TO 64
      Q1=NED
      Q2=NED-1
      Q1=1D0/Q1
      DO 50 L=1,4
      M=L+4
      Q3=RMD(L)
      Q4=Q1*Q3
      RMD(L)=Q4
      IF(L.LT.5) PM(L)=Q4                                               REL.18
      IF(NED.GE.2.AND.L.LE.NC) GO TO 65
      RMD(M)=0D0
      GO TO 50
   65 RMD(M)=DSQRT((RMD(M)-Q1*Q3*Q3)/Q2)                                REL.13.1
   50 CONTINUE
      PM(1)=PM(1)-C(1,I)                                                REL.18
      PM(2)=PM(2)+C(1,I)-C(2,I)                                         REL.18
      IF(MSYS.EQ.1.AND.NC.NE.4) GO TO 1051                              REL.18
      PM(3)=PM(3)+C(2,I)-C(3,I)                                         REL.18
      GO TO 1052                                                        REL.18
 1051 PM(3)=PM(3)-C(1,I)+C(3,I)                                         REL.18
 1052 PM(4)=PM(4)-C(MSYS,I)+C(4,I)                                      REL.18
      IF(NC.EQ.1) PM(2)=0D0
      IF(NC.LT.3) PM(3)=0D0
      IF(K11K.LT.3) GO TO 25
      IF(NED.GT.1.AND.NC.LT.4)
     * WRITE(9,217) B(20),(B(L),L=1,3),B(5),B(6),(RMD(L),L=1,3)         REL.18
      IF(NED.GT.1.AND.NC.EQ.4)
     * WRITE(9,2217) B(20),(B(L),L=1,7),(RMD(L),L=1,4)                  REL.18
   64 IF(K11K.LT.3) GO TO 25
      IF(KPR.EQ.2) GO TO 98
      IF(NED.GT.1.AND.NC.LT.4)
     *   WRITE(9,221) (B(L),L=8,10),B(12),B(13),(RMD(L),L=5,7)          REL.18
      IF(NED.GT.1.AND.NC.EQ.4)
     *   WRITE(9,2221) (B(L),L=8,14),(RMD(L),L=5,8)                     REL.18
      IF(NC.LT.4)
     * WRITE(9,222) (PRM(L),L=1,3),PRM(5),PRM(6),(PM(L),L=1,3)
      IF(NC.EQ.4) WRITE(9,2222) PRM,PM
      GO TO 25
   98 IF(NEX.GT.1.AND.NC.LT.4) WRITE(9,221) (B(L),L=8,10),B(12),B(13)   REL.18
      IF(NEX.GT.1.AND.NC.EQ.4) WRITE(9,2221) (B(L),L=8,14)              REL.18
      IF(NC.LT.4) WRITE(9,222) (PRM(L),L=1,3),PRM(5),PRM(6)
      IF(NC.EQ.4) WRITE(9,2222) PRM
   25 CONTINUE
      GO TO 1
C
C
C     COMPUTING THE COLOUR COEFFICIENTS
C
    7 IF(L123.LT.0) GO TO 2
      JN=JES(1)+1
      CALL RES(JN,ACV,BS,HHH)
      IF(K12V.LT.2) GO TO 1003
      JN1=1
      GO TO 1016
 1003 IF(K12V.LT.1) GO TO 1005
      JN1=2
      GO TO 1016
 1005 JN1=4
 1016 DO 1017 J=1,JN1
 1017 HV(J)=HHH(J)
      IF(K12K.EQ.0) HV(5)=HHH(JN-1)
      HV(6)=HHH(JN)
C
      IF(NC.LT.2) GO TO 1004                                            REL.14
      JN=JES(2)+1
      CALL RES(JN,ACB,BS,HHH)
      IF(K12B.LT.2) GO TO 1018
      JN1=1
      GO TO 1019
 1018 IF(K12B.LT.1) GO TO 1020
      JN1=2
      GO TO 1019
 1020 JN1=4
 1019 DO 1021 J=1,JN1
 1021 HB(J)=HHH(J)
      IF(K12K.EQ.0) HB(5)=HHH(JN-1)
      HB(6)=HHH(JN)
C
      IF(NC.LT.3) GO TO 1004                                            REL.14
      JN=JES(3)+1
      CALL RES(JN,ACU,BS,HHH)
      IF(K12U.LT.2) GO TO 1022
      JN1=1
      GO TO 1023
 1022 IF(K12U.LT.1) GO TO 1024
      JN1=2
      GO TO 1023
 1024 JN1=4
 1023 DO 1025 J=1,JN1
 1025 HU(J)=HHH(J)
      IF(K12K.EQ.0) HU(5)=HHH(JN-1)
      HU(6)=HHH(JN)
C
      IF(NC.LT.4) GO TO 1004
      JN=JES(4)+1
      CALL RES(JN,ACW,BS,HHH)
      IF(K12W.LT.2) GO TO 1026
      JN1=1
      GO TO 1027
 1026 IF(K12W.LT.1) GO TO 1028
      JN1=2
      GO TO 1027
 1028 JN1=4
 1027 DO 1029 J=1,JN1
 1029 HW(J)=HHH(J)
      IF(K12K.EQ.0) HW(5)=HHH(JN-1)
      HW(6)=HHH(JN)
 1004 DO 1002 J=5,23,6
      IF(H(J).GT.0D0) H(J)=0D0
 1002 CONTINUE
      ITER=ITER+1
      Q=NUC-1
      Q=1D0/Q
      DO 36 J=1,NC
   36 RMS(J)=DSQRT(Q*RMS(J))
      WRITE(6,216) ITER
      WRITE(6,227)
      WRITE(6,207) H
      IF(K11K.EQ.0) GO TO 18
      WRITE(9,216) ITER
      WRITE(9,227)
      WRITE(9,207) H
   18 DO 37 J=1,NC
      IF(DABS(RMS(J)-RM(J)).GT.7D-5) GO TO 38
   37 CONTINUE
      DO 29 J=1,24
      IF(DABS(H(J)-HH(J)).GT.7D-4) GO TO 38
   29 CONTINUE
      L123=-1
      GO TO 39
   38 L123=1
      RM(1)=RMS(1)
      RM(2)=RMS(2)
      RM(3)=RMS(3)
      RM(4)=RMS(4)
C
      DO 44 J=1,24
      HH(J)=H(J)
   44 CONTINUE
   39 REWIND 3
      REWIND 11
      WRITE(6,215) RMS
      IF(K11K.GT.0) WRITE(9,215) RMS
      READ(3,107) I,J,K
      M=3
      IF(I.NE.0) M=M+1
      IF(J.NE.0) M=M+1
      IF(K.NE.0) M=M+1
      DO 40 J=1,M
   40 READ(3,102) Q
      GO TO 5
C
    2 CONTINUE
      IF(NFIL1.NE.0) ENDFILE 1
      IF(NFIL2.NE.0) ENDFILE 2
      STOP 7
      END
C
C
      SUBROUTINE DATABC
C
C     Input of data of types A, B, C, D and E                           REL.15
C
C     Modified June 11 and July 15, 2005                                REL.15
C
C     Modified July 3, 2007  data E with sky after each star            REL.16
C
C     Last label is 82, 1 & 59 not used                                 REL.16
C
C
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER*2 KAL(4),ST(30),NT
C
C$LARGE: S,V,TT,VV,NK,NKK,C,NH,IHD,NT                                    REL.15
C
C
      COMMON /DATA/ STRED,U(32),UI(32),DIG,VEX(4),                      REL.18
     *   S(100000,4),V(100000,4),PAS,TT(100000,4),VV(100000,4),         REL.18
     *   C(4,2000),B(12),G(28),VJ(4),BR(6),AVE,                         REL.18
     *   EXT(4),KH(4),NC,NS,NK(100000,4),NKK(100000,4),NH(2000,4),      REL.18
     *   NMIN,NMAX,NDIG,NKAL,IHD(2000),NT(2000)                         REL.18
      COMMON /KLICE/
     *K1K,K2K,K3K,K4K,K5K,K6K,K7K,K8K,K9K,K10K,K11K,K12K,K22K
      COMMON /DTC/ DTC,HNL,L123
C
      DIMENSION O(4),KD(4),SO(32,4,2),VO(32,4,2)
C
      EXTERNAL ORDER,MOVE                                               REL.13
C
      DATA ST/2H1A,2H1B,2H1C,2H1D,2H1E,2H1F,
     1        2H2A,2H2B,2H2C,2H2D,2H2E,2H2F,
     2        2H3A,2H3B,2H3C,2H3D,2H3E,2H3F,
     3        2H4A,2H4B,2H4C,2H4D,2H4E,2H4F,
     4        2H5A,2H5B,2H5C,2H5D,2H5E,2H5F/
C
  101 FORMAT(I3,2F3.0,3(1X,A2,F4.0),3F4.0)
  102 FORMAT(I1,I4,2F3.0,F9.6,6F10.0)
  103 FORMAT(I3,3F3.0,3(I2,F5.0),3F6.0)
  104 FORMAT(I1,I4,2F3.0,F9.6,4F10.0,4F5.0)
  105 FORMAT(I3,3F3.0,4(I2,F5.0),4F6.0)
  106 FORMAT(I3,I5,2F3.0,F9.6,F11.0)
C
C
  201 FORMAT(1X,3I3,3(1X,A2,F5.0),3F5.0)
  202 FORMAT(//5X,'A LIST OF INPUT MEASUREMENTS'/)
  203 FORMAT(1X,I5,2I3,F9.5,6F15.4)
  204 FORMAT(1X,I1,I4,2I3,F9.5,F15.4)
  205 FORMAT(1X,'DEAD TIME CORRECTED:',6F15.4)
  206 FORMAT(4X,2HNS,5X,4HTIME,28X,4HSTAR,44X,3HSKY/
     1       29X,1HV,14X,1HB,14X,1HU,17X,1HV,14X,1HB,14X,1HU/
     2       9X,'H  M  S')
  207 FORMAT(1X,5HC  NS,5X,4HTIME,8X,'GAIN&DEFLECTION',2X,
     1       'DEAD-TIME CORRECTED'/9X,'H  M  S')
  208 FORMAT(2X,'NS  TIME',11X,'STAR',16X,'SKY'/14X,
     1       1HV,7X,1HB,7X,1HU,6X,1HV,4X,1HB,4X,1HU/7X,1HH,2X,1HM)
  209 FORMAT(1H+,40X,F15.4)
C
  300 FORMAT(/63(2H ?)/)
  301 FORMAT(7X,'STAR NO.',I4,', MISSING IN THE TABLE OF OBJECTS,',
     1       ' IN RECORD')
  302 FORMAT(7X,'INADMISSIBLE GAIN CODE IN RECORD')
  303 FORMAT(7X,'TOO HIGH GAIN, NOT AVAILABLE IN TABLE OF GAINS,',
     1       ' IN RECORD')
  304 FORMAT(7X,'UNEQUAL NUMBER OF OBSERVATIONS IN V(',I3,'), B(',I3,
     1       '), U(',I3,') AND W(',I3,1H))
  305 FORMAT(7X,'NO SKY DEFLECTION AVAILABLE FOR GAIN',I3,
     1       ' IN COLOUR',I2)
  306 FORMAT(7X,'INADMISSIBLE COLOUR CODED IN RECORD')
  307 FORMAT(7X,'Spacing of observations of star',                      REL.13
     1      I4,/7X,' starting at',F10.5,                                REL.13
     2      ' in different passbands'/7X,                               REL.13
     3      'is larger than the averaging constant',                    REL.13
     4      F12.7,'d =',F7.1,'s'/7X,'specified',                        REL.13
     5      ' for this night.'//7X,'Please, increase this',             REL.13
     6      ' constant in the respective record'/7X,                    REL.13
     7      'of the input data and run the program once more')          REL.13
  308 FORMAT(7X,'Deflection of star',I4,' of',F15.5/                    REL.13
     1       7X,'is smaller than sky reading of',F15.5/                 REL.13
     2       7X,'at',F15.6)                                             REL.13
  333 FORMAT(5X,'ERROR  2',3X,'INPUT DATA SYNTAX ERRORS:')
  351 FORMAT(9X,3I3,F9.5,6F15.4)
  352 FORMAT(1H+,67X,I1,I4,2I3,F9.5,F15.4)
  353 FORMAT(1H+,67X,3I3,3(1X,A2,F5.0),3F5.0)
  354 FORMAT(1H+,67X,I3,I5,2I3,F9.5,F15.4)                              REL.14.1
C
C     INITIALIZATION OF THE PARAMETERS AND DATA FIELDS
C
      IN=0
      KC=NC
      JA=1
      KONEC=0
      BIG=NDIG
      AV=AVE/86400D0                                                    REL.13
      KAM=IABS(K5K)+1
      KAMO=2                                                            REL.14.1
      IF(KAM.NE.5) GO TO 75                                             REL.14.1
      KAMO=KAM                                                          REL.14.1
      KAM=2                                                             REL.14.1
   75 DO 1 J=1,NC                                                       REL.14.1
      KH(J)=0
      DO 1 K=1,NS
    1 NH(K,J)=0
      IER=0
      NMIN=999
      NMAX=1
      NSMIN=10000
      NSMAX=0
   47 IF(KAM.NE.2) GO TO 2
      DO 27 J=1,NC
      KD(J)=1
      DO 27 K=1,NKAL
      VO(K,J,1)=0D0
   27 VO(K,J,2)=0D0
C
C     INPUT OF DATA
C
    2 JB=1
      GO TO (14,15,16,10), KAM
C
C     DATA OF TYPE A
   14 IF(NC.LT.4) READ(11,102) JA,N,Q,Q1,Q2,(B(I),I=1,3),(O(I),I=1,3)
      IF(NC.EQ.4) READ(11,104) JA,N,Q,Q1,Q2,(B(I),I=1,4),(O(I),I=1,4)
      GO TO 6
C
C     DATA OF TYPE B & E                                                REL.14.1
   15 IF(KAMO.EQ.2) GO TO 23                                            REL.14.1
   56 READ(11,103) N                                                    REL.14.1
      IF(N.LT.0) GO TO 56                                               REL.14.1
      BACKSPACE 11                                                      REL.14.1
      READ(11,106) JB,N,Q,Q1,Q2,Q4                                      REL.14.1
      Q4=Q4+BIG                                                         REL.15
      GO TO 50                                                          REL.14.1
   23 READ(11,102) JB,N,Q,Q1,Q2,Q4                                      REL.14.1
   50 KC=JB
      IF(K1K.EQ.1.AND.N.GT.NSMAX) NSMAX=N                               REL.13
      IF(K1K.EQ.1.AND.N.LT.NSMIN) NSMIN=N                               REL.13
      GO TO 6
C
C     DATA OF TYPE C     (Hvar 1979-1990)
   16 READ(11,101) N,Q,Q1,(KAL(I),B(I),I=1,3),(O(I),I=1,3)
      Q2=0D0
      GO TO 6
C
C     DATA OF TYPE D    (Hvar since 1991)
   10 READ(11,103) N
      IF(N.LT.0) GO TO 10
      BACKSPACE 11
      IF(NC.LT.4)
     *  READ(11,103) N,Q,Q1,Q2,(KAL(I),B(I),I=1,3),(O(I),I=1,3)
      IF(NC.EQ.4)
     *  READ(11,105) N,Q,Q1,Q2,(KAL(I),B(I),I=1,4),(O(I),I=1,4)
C
    6 IF(N.EQ.0) GO TO 9
      IF(L123.GT.0.AND.K9K.LT.100) GO TO 2
      J=Q
      J1=Q1
C
    3 IF(KAM.NE.2) GO TO 60
      IF(JB.LE.NC.AND.JB.GE.1) GO TO 61
      JER=6
      GO TO 20
   61 IF (DTC.NE.0D0) GO TO 11
      L=DINT(DIG*Q4)
      IF (L.GT.0.AND.L.LE.NKAL) GO TO 11
      JER=3
      IF (L.LE.0) JER=2
      GO TO 20
   11 B(JB)=Q4
   60 IF(N.GT.0.OR.KAM.EQ.4) GO TO 54
      IF(KAM-2) 55,4,55
   54 IF(N.LE.NS.AND.IHD(N).GT.0) GO TO 4
   55 JER=1
C
C      ERROR INDICATIONS
C
   20 IF(IER.NE.0) GO TO 19
      WRITE(9,300)
      WRITE(9,333)
      IER=1
   19 IF(JER.EQ.1) WRITE(9,301) N
      IF(JER.EQ.2) WRITE(9,302)
      IF(JER.EQ.3) WRITE(9,303)
      IF(JER.EQ.6) WRITE(9,306)
      IF(JER.NE.5) GO TO 62
      WRITE(9,305) J,JB
      GO TO 31
   62 IF(JER.NE.4) GO TO 5
      WRITE(9,304) KH
      GO TO 37
    5 GO TO (51,52,53,51), KAM
   51 WRITE(9,351) N,J,J1,Q2,B(1),B(2),B(3),O(1),O(2),O(3)
      GO TO 2
   52 IF(KAMO.EQ.2) WRITE(9,352) JB,N,J,J1,Q2,Q4                        REL.14.1
      IF(KAMO.EQ.5) WRITE(9,354) JB,N,J,J1,Q2,Q4                        REL.14.1
      GO TO 2
   53 WRITE(9,353) N,J,J1,(KAL(I),B(I),I=1,3),(O(I),I=1,3)
      GO TO 2
C
C     GAINS DECODED
C
    4 IF(DTC.NE.0D0) GO TO 17
      GO TO (25,25,24,21), KAM
C
C     DATA D
C
   21 DO 22 L=JB,KC
      KAL(L)=KAL(L)+1
      JA=KAL(L)
      IF(JA.GT.0.AND.JA.LE.NKAL) GO TO 22
      JER=3
      IF(JA.LE.0) JER=2
      GO TO 20
   22 CONTINUE
      GO TO 17
C
C     DATA C
C
   24 DO 13 K=1,NC
      DO 12 L=1,30
      I=L
      IF(KAL(K).EQ.ST(L)) GO TO 46
   12 CONTINUE
      JER=2
      GO TO 20
   46 IF(I.LE.NKAL) GO TO 43
      JER=3
      GO TO 20
   43 KAL(K)=I
   13 CONTINUE
      GO TO 17
C
C     DATA A & SKY DATA B
C
   25 IF(KAM.EQ.2.AND.N.GT.0) GO TO 17
      DO 26 L=JB,KC
      Q4=B(L)
      JA=DIG*Q4
      IF(JA.GT.0.AND.JA.LE.NKAL) GO TO 44
      JER=3
      IF(JA.LE.0) JER=2
      GO TO 20
   44 Q5=NDIG*JA
      B(L)=Q4-Q5
   26 KAL(L)=JA
C
   17 IF(Q.LT.15D0) Q=Q+24D0
      Q=(Q+Q1/60D0+Q2/3600D0+PAS)/24D0
      QEND=Q
      IN=IN+1
      IF(IN.EQ.1) Q3=Q
      IF(N.LT.0) GO TO 36
      DO 8 J=JB,KC
      KH(J)=KH(J)+1
      IM=KH(J)
      NK(IM,J)=N
      NH(N,J)=NH(N,J)+1
      S(IM,J)=Q
      IF(DTC.NE.0D0.OR.KAM.NE.2) GO TO 48
      V(IM,J)=B(J)
      GO TO 8
   48 I=KAL(J)
      IF(DTC.EQ.0D0) GO TO 18
      I=1
      CALL DEAD(B(J))
      IF(K5K.GE.0) GO TO 76
      IF(B(J).LE.0D0) GO TO 82                                          REL.13
      V(IM,J)=19D0-2.5D0*DLOG10(B(J))
      GO TO 8
   76 GO TO (35,34,35), KAM
   34 V(IM,J)=B(J)+BIG
      GO TO 8
   35 CALL DEAD(O(J))
      GO TO 77
   18 Q77=B(J)*UI(I)
      Q77=Q77*(1D0-HNL*Q77)
      Q78=O(J)*UI(I)
      Q78=Q78*(1D0-HNL*Q78)
      V(IM,J)=11D0-2.5D0*DLOG10(Q77-Q78)
      GO TO 8
   77 IF(B(J).GT.O(J)) GO TO 81                                         REL.13
   82 WRITE(9,308) N,B(J),O(J),S(IM,J)                                  REL.13
      STOP 1313                                                         REL.13
   81 V(IM,J)=U(I)-2.5D0*DLOG10(B(J)-O(J))+11D0                         REL.13
    8 CONTINUE
   49 IF(N.LT.NMIN) NMIN=N
      IF(N.GT.NMAX) NMAX=N
      GO TO 2
C
C     DATA B: SKY DEFLECTIONS SAVED
C
   36 IF(DTC.EQ.0D0) GO TO 7
      CALL DEAD(B(JB))
    7 VO(JA,JB,2)=B(JB)
      SO(JA,JB,2)=Q
      IF(DABS(SO(JA,JB,1)-Q).LT.8D-2.AND.VO(JA,JB,1).NE.0D0) GO TO 29
      VO(JA,JB,1)=B(JB)
      SO(JA,JB,1)=Q
C
C     DATA B: SKY DEFLECTIONS SUBTRACTED FROM STELLAR DEFLECTIONS
C
   29 J4=KH(JB)
      J5=KD(JB)
      IF(K5K.NE.-4) GO TO 57                                            REL.16
      Q2=V(J4,JB)                                                       REL.16
      J=DIG*Q2                                                          REL.16
      Q1=NDIG*J                                                         REL.16
      Y=VO(JA,JB,2)                                                     REL.16
      V(J4,JB)=U(J)-2.5D0*DLOG10(Q2-Q1-Y)+11D0                          REL.16
      GO TO 58                                                          REL.16
   57 IF (J4-J5) 31,30,30                                               REL.16
   30 IF(V(J5,JB).GT.BIG) GO TO 32
      J5=J5+1
      IF(J4.GE.J5) GO TO 30
   32 KD(JB)=J5
      IF(J4.LT.J5) GO TO 31
      DO 33 J1=J5,J4
      Q2=V(J1,JB)
      J=DIG*Q2
      IF(J.NE.JA) GO TO 33
      Q1=NDIG*J
      Y=0D0
      IF(K5K.LT.0) GO TO 40
      X1=SO(J,JB,1)
      X2=SO(J,JB,2)
      Y1=VO(J,JB,1)
      Y2=VO(J,JB,2)
      IF(Y2.NE.0D0) GO TO 28
      JER=5
      GO TO 20
   28 X=S(J1,JB)
      IF(X.LE.X1) GO TO 38
      IF(X.LE.X2) GO TO 39
      Y=Y2
      GO TO 40
   38 Y=Y1
      GO TO 40
   39 Y=Y1+(Y2-Y1)*(X-X1)/(X2-X1)
   40 V(J1,JB)=U(J)-2.5D0*DLOG10(Q2-Q1-Y)+11D0
   33 CONTINUE
   31 SO(JA,JB,1)=SO(JA,JB,2)
      VO(JA,JB,1)=VO(JA,JB,2)
   58 IF(KONEC) 2,2,41
C
C
C     END OF DATA FOUND
C
    9 IF(KAM.NE.2.OR.K5K.EQ.-4) GO TO 37                                REL.16
      IF(K5K.LT.0.AND.DTC.NE.0D0) GO TO 45
C
C     END OF TYPE B DATA
C
      KONEC=1
      JB=0
   42 JB=JB+1
      IF(JB.GT.NC) GO TO 45
      JA=0
   41 JA=JA+1
      IF(JA-NKAL) 29,29,42
   45 IF(NC.LE.1.OR.K1K.EQ.1) GO TO 37                                  REL.13
      JER=4
      IF(KH(1).NE.KH(2)) GO TO 20
      IF(NC.LE.2) GO TO 37
      IF(KH(2).NE.KH(3)) GO TO 20
      IF(NC.LE.3) GO TO 37
      IF(KH(3).NE.KH(4)) GO TO 20
C
   37 STRED=5D-1*(QEND+Q3)
      IF(IER.NE.0) WRITE(9,300)
      IF(K1K.NE.1.OR.NC.EQ.1) RETURN                                    REL.13
      J=KH(1)                                                           REL.13
      POSL=S(J,1)                                                       REL.13
      J=KH(2)                                                           REL.13
      IF(NC.GT.1) POSL=DMAX1(POSL,S(J,2))                               REL.13
      J=KH(3)                                                           REL.13
      IF(NC.GT.2) POSL=DMAX1(POSL,S(J,3))                               REL.13
      J=KH(4)                                                           REL.13
      IF(NC.GT.3) POSL=DMAX1(POSL,S(J,4))                               REL.13
      JUST=0                                                            REL.13
      DO 70 N=NSMIN,NSMAX                                               REL.13
      IF(NH(N,1).EQ.0) GO TO 70                                         REL.13
      DO 63 J=1,NC                                                      REL.13
   63 KD(J)=1                                                           REL.13
   80 DO 79 J=1,NC                                                      REL.13
   79 KAL(J)=0                                                          REL.13
      M=0                                                               REL.13
      DO 64 L=1,NC                                                      REL.13
      KK=KH(L)                                                          REL.13
      LL=KD(L)                                                          REL.13
      IF(LL.GT.KK) GO TO 64                                             REL.13
      DO 65 K=LL,KK                                                     REL.13
      IF(NK(K,L).NE.N) GO TO 65                                         REL.13
      KD(L)=K+1                                                         REL.13
      KAL(L)=1                                                          REL.13
      VEX(L)=S(K,L)                                                     REL.13
      VJ(L)=V(K,L)                                                      REL.13
      M=M+1                                                             REL.13
      GO TO 64                                                          REL.13
   65 CONTINUE                                                          REL.13
      M=M+KAL(L)                                                        REL.13
      TMIN=S(K,1)                                                       REL.13
   64 CONTINUE                                                          REL.13
      IF(M.EQ.0) GO TO 70                                               REL.13
      IF(M.LT.NC) GO TO 71                                              REL.13
      TMIN=DMIN1(VEX(1),VEX(2))                                         REL.13
      TMAX=DMAX1(VEX(1),VEX(2))                                         REL.13
      IF(NC.LE.2) GO TO 67                                              REL.13
      TMIN=DMIN1(TMIN,VEX(3))                                           REL.13
      TMAX=DMAX1(TMAX,VEX(3))                                           REL.13
   66 IF(NC.LT.4) GO TO 67                                              REL.13
      TMIN=DMIN1(TMIN,VEX(4))                                           REL.13
      TMAX=DMAX1(TMAX,VEX(4))                                           REL.13
   67 IF((TMAX-TMIN).LE.AV) GO TO 68                                    REL.13
   71 WRITE(9,307) N,TMIN,AV,AVE                                        REL.13
      STOP 13                                                           REL.13
   68 JUST=JUST+1                                                       REL.13
      ZAD=TMIN+AV                                                       REL.13
      DO 69 L=1,NC                                                      REL.13
      NKK(JUST,L)=N                                                     REL.13
      KK=KH(L)                                                          REL.13
      LL=KD(L)                                                          REL.13
      DO 72 K=LL,KK                                                     REL.13
      IF(S(K,L).GT.ZAD) GO TO 69                                        REL.13
   73 IF(NK(K,L).NE.N) GO TO 72                                         REL.13
      KD(L)=K+1                                                         REL.13
      KAL(L)=KAL(L)+1                                                   REL.13
      VEX(L)=VEX(L)+S(K,L)                                              REL.13
      VJ(L)=VJ(L)+V(K,L)                                                REL.13
   72 CONTINUE                                                          REL.13
   69 CONTINUE                                                          REL.13
      DO 78 J=1,NC                                                      REL.13
      TT(JUST,J)=VEX(J)/KAL(J)                                          REL.13
      VV(JUST,J)=VJ(J)/KAL(J)                                           REL.13
   78 CONTINUE                                                          REL.13
      IF(ZAD.LT.POSL) GO TO 80                                          REL.13
   70 CONTINUE                                                          REL.13
      CALL GENSHL(JUST,ORDER,MOVE)                                      REL.13
      DO 74 J=1,NC                                                      REL.13
      KH(J)=JUST                                                        REL.13
      DO 74 K=1,JUST                                                    REL.13
      NK(K,J)=NKK(K,J)                                                  REL.13
      V(K,J)=VV(K,J)                                                    REL.13
      S(K,J)=TT(K,J)                                                    REL.13
   74 CONTINUE                                                          REL.13
      RETURN                                                            REL.13
      END
C
C
      SUBROUTINE DEAD(A)
C
C     CALCULATION OF THE DEAD-TIME CORRECTION
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /DTC/ T,HNL,L123
C
      IF(A.EQ.0D0) RETURN
      B=A
    1 C=B
      B=A*DEXP(T*B)
      IF(DABS((B-C)/B).GT.1.D-8) GO TO 1
      A=B
      RETURN
      END
C
C
      SUBROUTINE MAG(INIT,M,AI1,AI2,AI3,AI4,H)
C
C     Calculates the extraterrestrial magnitudes VEX
C     and Johnson's magnitudes VJ
C
C     AI1, AI2, AI3, AI4: the air masses corresponding to V, B, U, and W obs.
C     VEX(1)... v0, VEX(2)... b0, VEX(3)... u0, VEX(4)... w0,
C
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER*2 NT
C
C$LARGE: S,V,TT,VV,NK,NKK,C,NH,IHD,NT                                    REL.15
C
C
      DIMENSION H(24),P(4),X(3)                                         REL.14
C
C
      COMMON /DATA/ STRED,U(32),UI(32),DIG,VEX(4),                      REL.18
     *   S(100000,4),V(100000,4),PAS,TT(100000,4),VV(100000,4),         REL.18
     *   C(4,2000),B(12),G(28),VJ(4),BR(6),AVE,                         REL.18
     *   EXT(4),NM(4),NC,NS,NK(100000,4),NKK(100000,4),NH(2000,4),      REL.18
     *   NMIN,NMAX,NDIG,NKAL,IHD(2000),NT(2000)                         REL.18
C
      COMMON /WECKA/ W1,W2,W3,W4,W5,W6,W7,W8,W9,W10                     REL.14.1
      COMMON /KLICE/
     *K1K,K2K,K3K,K4K,K5K,K6K,K7K,K8K,K9K,K10K,K11K,K12K,K22K
C
C
      IF(INIT.NE.0) GO TO 11
      IF(NC.LT.4) VJ(4)=4D8
      IF(NC.GT.2) GO TO 4
      L=NK(M,1)
      VJ(3)=1D8
      UM=C(3,L)-C(2,L)
      IF(NC.EQ.2) GO TO 4
      VJ(2)=3D20
      BM=C(2,L)-C(1,L)
C
    4 B(1)=S(M,1)-STRED                                                 REL.14
      B(2)=S(M,2)-STRED                                                 REL.14
      B(3)=S(M,3)-STRED                                                 REL.14
      B4=S(M,4)-STRED                                                   REL.14
      EXT(1)=G(5)                                                       REL.14
      EXT(2)=G(6)                                                       REL.14
      EXT(3)=G(7)                                                       REL.14
      EXT(4)=G(8)                                                       REL.14
      IF(K6K.LT.100) GO TO 13                                           REL.14
      Q=B(1)                                                            REL.14
      Q2=Q*Q                                                            REL.14
      Q3=Q*Q2                                                           REL.14
      Q4=Q*Q3                                                           REL.14
      Q5=Q*Q4                                                           REL.14
      EXT(1)=EXT(1)+G(9)*Q+G(13)*Q2+G(17)*Q3+G(21)*Q4+G(25)*Q5          REL.14
      Q=B(2)                                                            REL.14
      Q2=Q*Q                                                            REL.14
      Q3=Q*Q2                                                           REL.14
      Q4=Q*Q3                                                           REL.14
      Q5=Q*Q4                                                           REL.14
      EXT(2)=EXT(2)+G(10)*Q+G(14)*Q2+G(18)*Q3+G(22)*Q4+G(26)*Q5         REL.14
      Q=B(3)                                                            REL.14
      Q2=Q*Q                                                            REL.14
      Q3=Q*Q2                                                           REL.14
      Q4=Q*Q3                                                           REL.14
      Q5=Q*Q4                                                           REL.14
      EXT(3)=EXT(3)+G(11)*Q+G(15)*Q2+G(19)*Q3+G(23)*Q4+G(27)*Q5         REL.14
      Q=B4                                                              REL.14
      Q2=Q*Q                                                            REL.14
      Q3=Q*Q2                                                           REL.14
      Q4=Q*Q3                                                           REL.14
      Q5=Q*Q4                                                           REL.14
      EXT(4)=EXT(4)+G(12)*Q+G(16)*Q2+G(20)*Q3+G(24)*Q4+G(28)*Q5         REL.16.2
   13 B(4)=EXT(2)-EXT(1)                                                REL.14
      B(5)=EXT(3)-EXT(2)                                                REL.14
      B(6)=AI1*B(4)
      B(7)=AI2*B(4)
      B(8)=AI3*B(5)
      B(9)=B(7)*B(7)
      B(10)=H(11)*B(7)
      B(11)=H(11)*B(9)
      VEX(1)=V(M,1)-G(1)-EXT(1)*AI1                                     REL.14
      IF(K6K.LT.100) VEX(1)=VEX(1)-B(1)*G(9)-B(1)*B(1)*G(13)            REL.14
      IF(K1K.EQ.3) GO TO 12                                             REL.14
      IF(NC.EQ.1) GO TO 3
      VEX(2)=V(M,2)-G(2)-EXT(2)*AI2                                     REL.14
      IF(K6K.LT.100) VEX(2)=VEX(2)-B(2)*G(10)-B(2)*B(2)*G(14)           REL.14
      IF(NC.EQ.2) GO TO 201
      VEX(3)=V(M,3)-G(3)-EXT(3)*AI3                                     REL.14
      IF(K6K.LT.100) VEX(3)=VEX(3)-B(3)*G(11)-B(3)*B(3)*G(15)           REL.14
      IF(NC.LT.4) GO TO 14                                              REL.14
      VEX(4)=V(M,4)-G(4)-EXT(4)*AI4                                     REL.14
      IF(K6K.LT.100) VEX(4)=VEX(4)-B4*G(12)-B4*B4*G(16)                 REL.14
   14 UB0=VEX(3)-VEX(2)                                                 REL.14
      UM=UB0
  201 IF(W4.NE.0.OR.K22K.NE.0) GO TO 10
      DO 9 J=1,NC
      VJ(J)=VEX(J)
    9 CONTINUE
      GO TO 8
   10 IF(K22K.EQ.0) GO TO 5
C
C     Bilinear transformation formulae
C
      Q=0D0
      T=0D0
      BR(1)=W1+B(10)-H(5)*B(6)
      BR(2)=-W2
      BR(3)=VEX(2)-VEX(1)+5D-1*(H(5)*B(6)*B(6)-B(11))+W5
      IF(NC.NE.2) GO TO 202
      BM=(BR(3)+W2*UM)/BR(1)
      GO TO 203
  202 BR(4)=-W7-B(10)
      BR(5)=W6+H(17)*B(8)
      BR(6)=UB0+5D-1*(B(11)-H(17)*B(8)*B(8))+W10
      CALL DP1(BR,VJ,2)
      BM=VJ(1)
      UM=VJ(2)
      GO TO 203
C
C     Cubic transformation in (B-V) and linear in (U-B)
C
    5 BV0=VEX(2)-VEX(1)
      BM=BV0
      I=0
    7 BS=BM
      US=UM
      I=I+1
      IF(NC.EQ.2) GO TO 6
      Q=BM*BM
      T=BM*Q
      UM=(UB0+(W7+B(10))*BM+W8*Q+W9*T+5D-1*(B(11)-H(17)*B(8)*B(8))+W10)
     *   /(W6+H(17)*B(8))
    6 P(3)=H(5)*B(6)-B(10)-W1
      P(4)=BV0+W2*UM-5D-1*(B(11)-H(5)*B(6)*B(6))+W5
      X(2)=100D0
      X(3)=100D0
      CALL KUBA(P,X)
      BM=X(1)
      Q=DABS(BM-BV0)
      T=DABS(X(2)-BV0)
      Q1=DABS(X(3)-BV0)
      IF(T.GT.Q) GO TO 1
      BM=X(2)
    1 IF(Q1.GT.T.OR.Q1.GT.Q) GO TO 2
      BM=X(3)
    2 IF(NC.EQ.2) GO TO 3
      IF(DABS(UM-US).GT.1D-6.AND.I.LT.20) GO TO 7
      IF(DABS(BM-BS).GT.1D-6.AND.I.LT.20) GO TO 7
    3 Q=BM*BM
      T=BM*Q
  203 VJ(1)=VEX(1)-H(1)*BM-H(2)*UM-H(3)*Q-H(4)*T-
     *      H(5)*B(6)*(BM+5D-1*B(6))-H(6)
      IF(NC.EQ.1) GO TO 8
      VJ(2)=BM+VJ(1)
      IF(NC.EQ.2) GO TO 8
      VJ(3)=UM+VJ(2)
      IF(NC.EQ.4) VJ(4)=VEX(4)-H(19)*BM-H(20)*UM-H(21)*Q-H(22)*T-
     *            H(23)*AI4*B(5)*(UM+5D-1*AI4*B(5))-H(24)
C
    8 V(M,1)=VJ(1)
      V(M,2)=VJ(2)
      V(M,3)=VJ(3)
      V(M,4)=VJ(4)
      RETURN
C
   12 Q=H(5)*EXT(1)*AI1                                                 REL.14
      VJ(1)=(VEX(1)-5D-1*EXT(1)*AI1*Q-H(6))/(H(1)+Q)                    REL.14
      GO TO 8                                                           REL.14
C
C     Initialisation of auxiliary variables related to H coef.
C
   11 W1=1D0+H(7)-H(1)
      W2=H(2)-H(8)
      W3=H(3)-H(9)
      W4=H(4)-H(10)
      W5=H(6)-H(12)
      W6=1D0+H(14)-H(8)
      W7=H(7)-H(13)
      W8=H(9)-H(15)
      W9=H(10)-H(16)
      W10=H(12)-H(18)
      P(1)=W4
      P(2)=W3
      RETURN
      END
C
C
      SUBROUTINE XYZF(I,J,KL5,Q1,Q2,H,X,Y,Z,W,FC)
C
C     AN AUXILIARY SUBROUTINE TO COMPUTE X, Y, Z, AND FC
C     X1...air mass, X2...air mass*time OR time (for K6K=11)            REL.14
C     X3...air mass*(time)^2, X4...air mass*(time)^3                    REL.14
C     Y for B, Z for U, W for v
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(6),Y(6),Z(6),W(6),FC(4),H(24)                         REL.14
      INTEGER*2 NT
      INTEGER*4 HD
C
C$LARGE: S,V,TT,VV,NK,NKK,C,NH,HD,NT                                     REL.15
C
C
C
      COMMON /DATA/ STRED,U(32),UI(32),DIG,VEX(4),                      REL.18
     *   S(100000,4),V(100000,4),PAS,TT(100000,4),VV(100000,4),         REL.18
     *   C(4,2000),E(12),G(28),VJ(4),BR(6),AVE,                         REL.18
     *   EXT(4),NM(4),NC,NS,NK(100000,4),NKK(100000,4),NH(2000,4),      REL.18
     *   NMIN,NMAX,NDIG,NKAL,HD(2000),NT(2000)                          REL.18
C
      COMMON /TIME/ GEO,DAT,SS,CS,DELKA,SE,CE,DSUN,HEL,
     *              HCAS,UHEL,AIR
C
      COMMON /KLICE/                                                    REL.14
     *K1K,K2K,K3K,K4K,K5K,K6K,K7K,K8K,K9K,K10K,K11K,K12K,K22K           REL.14
C
      IF(NC.EQ.1) GO TO 94
      Q=S(J,2)                                                          REL.14
      CALL HMOTA(Q1,Q2,Q+GEO)                                           REL.14
      Q=Q-STRED                                                         REL.14
      Y(1)=AIR
      Y(2)=AIR*Q                                                        REL.14
      IF(K6K.LT.100) Y(2)=Q                                             REL.14
      Y(3)=Y(2)*Q                                                       REL.14
      Y(4)=Y(3)*Q                                                       REL.14
      Y(5)=Y(4)*Q                                                       REL.14
      Y(6)=Y(5)*Q                                                       REL.14
      IF(KL5.NE.1) GO TO 55
      IF(NC.LT.4) GO TO 1
      Q=S(J,4)                                                          REL.14
      CALL HMOTA(Q1,Q2,Q+GEO)                                           REL.14
      Q=Q-STRED                                                         REL.14
      W(1)=AIR
      W(2)=AIR*Q                                                        REL.14
      IF(K6K.LT.100) W(2)=Q                                             REL.14
      W(3)=W(2)*Q                                                       REL.14
      W(4)=W(3)*Q                                                       REL.14
      W(5)=W(4)*Q                                                       REL.14
      W(6)=W(5)*Q                                                       REL.14
    1 IF(NC.LT.3) GO TO 94
      Q=S(J,3)                                                          REL.14
      CALL HMOTA(Q1,Q2,Q+GEO)                                           REL.14
      Q=Q-STRED                                                         REL.14
      Z(1)=AIR
      Z(2)=AIR*Q                                                        REL.14
      IF(K6K.LT.100) Z(2)=Q                                             REL.14
      Z(3)=Z(2)*Q                                                       REL.14
      Z(4)=Z(3)*Q                                                       REL.14
      Z(5)=Z(4)*Q                                                       REL.14
      Z(6)=Z(5)*Q                                                       REL.14
   94 Q=S(J,1)                                                          REL.14
      CALL HMOTA(Q1,Q2,Q+GEO)                                           REL.14
      Q=Q-STRED                                                         REL.14
      X(1)=AIR
      X(2)=AIR*Q                                                        REL.14
      IF(K6K.LT.100) X(2)=Q                                             REL.14
      X(3)=X(2)*Q                                                       REL.14
      X(4)=X(3)*Q                                                       REL.14
      X(5)=X(4)*Q                                                       REL.14
      X(6)=X(5)*Q                                                       REL.14
      GO TO 74
   55 X(1)=Y(1)
      Z(1)=Y(1)
      W(1)=Y(1)
      X(2)=Y(2)
      Z(2)=Y(2)
      W(2)=Y(2)
      X(3)=Y(3)
      Z(3)=Y(3)
      W(3)=Y(3)
      X(4)=Y(4)                                                         REL.14
      Z(4)=Y(4)                                                         REL.14
      W(4)=Y(4)                                                         REL.14
      X(5)=Y(5)                                                         REL.14
      Z(5)=Y(5)                                                         REL.14
      W(5)=Y(5)                                                         REL.14
      X(6)=Y(6)                                                         REL.14
      Z(6)=Y(6)                                                         REL.14
      W(6)=Y(6)                                                         REL.14
   74 Q6=C(1,I)
      Q7=C(2,I)
      Q11=Q7-Q6
      IF(K1K.EQ.3) GO TO 3                                              REL.14
      Q8=C(3,I)
      Q12=Q8-Q7
      Q9=Q11*Q11
      Q10=Q9*Q11
      EXT(1)=G(5)                                                       REL.14
      EXT(2)=G(6)                                                       REL.14
      EXT(3)=G(7)                                                       REL.14
      IF(K6K.LT.100) GO TO 13                                           REL.14
      EXT(1)=EXT(1)+G(9)*X(2)+G(13)*X(3)+                               REL.14
     *       G(17)*X(4)+G(21)*X(5)+G(25)*X(6)                           REL.14
      EXT(2)=EXT(2)+G(10)*Y(2)+G(14)*Y(3)+                              REL.14
     *       G(18)*Y(4)+G(22)*Y(5)+G(26)*Y(6)                           REL.14
      EXT(3)=EXT(3)+G(11)*Z(2)+G(15)*Z(3)+                              REL.14
     *       G(19)*Z(4)+G(23)*Z(5)+G(27)*Z(6)                           REL.14
   13 Q1=EXT(2)-EXT(1)                                                  REL.14
      Q2=EXT(3)-EXT(2)                                                  REL.14
      Q=X(1)*Q1
      CV=Q*(Q11+5D-1*Q)
      Q=Y(1)*Q1
      CB=Q*(Q11+5D-1*Q)
      Q=Z(1)*Q2
      CU=Q*(Q12+5D-1*Q)
      Q=W(1)*Q2
      CW=Q*(Q12+5D-1*Q)
      FC(1)=V(J,1)-H(1)*Q11-H(2)*Q12-H(3)*Q9-H(4)*Q10-H(5)*CV-Q6
      FC(2)=V(J,2)-H(7)*Q11-H(8)*Q12-H(9)*Q9-H(10)*Q10-H(11)*CB-Q7
      FC(3)=V(J,3)-H(13)*Q11-H(14)*Q12-H(15)*Q9-H(16)*Q10-H(17)*CU-Q8
      IF(NC.EQ.4) FC(4)=V(J,4)-H(19)*Q11-H(20)*Q12-H(21)*Q9-
     *            H(22)*Q10-H(23)*CW-C(4,I)
      RETURN
C
    3 FC(1)=V(J,1)-H(1)*Q11-H(5)*EXT(1)*X(1)*(Q11+5D-1*EXT(1)*X(1))     REL.14
      RETURN                                                            REL.14
      END
C
C
      SUBROUTINE INDX(L,IND,K)
C
C     COMPUTING THE INDEX OF THE NEXT MEASUREMENT OF A COMPARISON STAR
C
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*2 NT
C
C$LARGE: S,V,TT,VV,C,NK,NKK,NH,IHD,NT                                    REL.15
C
C
      COMMON /DATA/ STRED,U(32),UI(32),DIG,VEX(4),                      REL.18
     *   S(100000,4),V(100000,4),PAS,TT(100000,4),VV(100000,4),         REL.18
     *   C(4,2000),B(12),G(28),VJ(4),BR(6),AVE,                         REL.18
     *   EXT(4),NM(4),NC,NS,NK(100000,4),NKK(100000,4),NH(2000,4),      REL.18
     *   NMIN,NMAX,NDIG,NKAL,IHD(2000),NT(2000)                         REL.18
      J1=NM(1)
      DO 1 I=L,J1
      K=NK(I,1)
      J=NT(K)
      IF(J.NE.2.AND.J.NE.5.AND.J.NE.8) GO TO 1
      IND=I
      RETURN
    1 CONTINUE
      IND=-1
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION EPS(ROK)
C
C     INCLINATION OF THE ECLIPTIC FOR A GIVEN INSTANT
C     ROK=DATE(IN YEARS)-1900
C
      REAL*8 ROK
      EPS=0.409319743D0-2.2711D-6*ROK
      RETURN
      END
C
C
      SUBROUTINE RADEC(ALFA,DELTA,A,D,DAT,EQ)
C
C     EQUATOREAL COORDINATES FOR THE DATE OF OBSERVATION
C
      IMPLICIT REAL*8 (A-H,O-Z)
      Z=2.4368674107D-4+1.07871D-9*(DAT)
      E=EPS(EQ)
      H=Z*DSIN(E)
      R=DAT-EQ
      ALFA=A+R*(H*DSIN(A)*DSIN(D)/DCOS(D)+Z*DCOS(E))
      DELTA=D+R*H*DCOS(A)
      RETURN
      END
C
C
C
      DOUBLE PRECISION FUNCTION GJD(DAY,MON,IY)
C
C     Geocentric Julian date from day, month and year after Vondrak 2001
C
      REAL*8 DAY
      I=IY
      J=MON
      IF(MON.LE.2) THEN
       I=I-1
       J=J+12
      ENDIF
      IA=I/100
      IB=2-IA+IA/4
      IF(IY.GE.1583) GO TO 1
      IF(IY.LE.1581) then
       IB=0
       GO TO 1
      ENDIF
      IF(MON.LT.10.OR.(MON.EQ.10.AND.DAY.LE.5.)) IB=0
    1 GJD=DAY+IB+INT(365.25D0*(I+4716))+INT(30.6001D0*(J+1))-1524.5D0
      RETURN
      END
C
C
      SUBROUTINE SUN(T)
C
C     LONGITUDE OF THE SUN AND THE TRUE ANOMALY
C     FOR A GIVEN J.D. AND CORRESPONDING DAT
C     T IS THE MEAN TIME OF OBSERVATIONS(UT) IN FRACTIONS OF A DAY,
C     GEO IS THE J.D. OF THE BEGINNING OF THE DAY OF OBSERVATIO5
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /TIME/ GEO,DAT,SS,CS,DELKA,SE,CE,DSUN,HEL,
     1         HCAS,UHEL,AIR
C
      EC=1.675104D-2-4.18D-7*DAT
      PI=4.90822932D0+3.0005263D-4*DAT
      Q=EPS(DAT)
      SE=DSIN(Q)
      CE=DCOS(Q)
      J=DAT
      T=1.720197D-2*(T+GEO-2415020.3135D0-365.24219572D0*J)+
     +4.88692176D0-PI
C     KEPLER EQUATION ITERATED
      E=T
    1 Q=E
      E=T+EC*DSIN(E)
      IF(DABS(E-Q).GT.1D-9) GO TO 1
      Q=5D-1*E
      Q2=DCOS(Q)
      IF(Q2.EQ.0D0) GO TO 2
      Q1=DSIN(Q)
      Q=2D0*DATAN(Q1/Q2*DSQRT((1D0+EC)/(1D0-EC)))
      GO TO 3
    2 Q=3.14159265358979D0
    3 DSUN=PI+Q
      HEL=5.775518379D-3*(1D0-EC*EC)/(1D0+EC*DCOS(Q))
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION HK(A,D)
C
C     HELIOCENTRIC CORRECTION OF TIME FOR
C     GIVEN EQUATOREAL COORDINATES
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /TIME/ GEO,DAT,SS,CS,DELKA,SE,CE,DSUN,HEL,
     *              HCAS,UHEL,AIR
      HK=GEO-HEL*(DCOS(A)*DCOS(D)*DCOS(DSUN)+(CE*DSIN(A)*DCOS(D)+
     1   SE*DSIN(D))*DSIN(DSUN))
      RETURN
      END
C
C
      SUBROUTINE HMOTA(A,D,T)
C
C     Computes sidereal time, hour angle and air mass
C     for a given J.D. = T and equatoreal coordinates A and D
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /TIME/ GEO,DAT,SS,CS,DELKA,SE,CE,DSUN,HEL,
     *              HCAS,UHEL,AIR
C
      HCAS=DMOD(5.9492410D-1+1.002737909D0*(T-2433763.5D0),1D0)
      HCAS=6.2831853D0*(HCAS+DELKA)
      UHEL=DMOD(HCAS-A,6.283185D0)
      Q=SS*DSIN(D)+CS*DCOS(D)*DCOS(UHEL)
      AIR=1D0/Q
      Z=AIR-1D0                                                         REL.13.2
      AIR=AIR-Z*(1.8167D-3+Z*(2.875D-3+8.083D-4*Z))                     REL.13.2
      RETURN
      END
C
C
      SUBROUTINE NUL(N,A)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1)
      DO 1 J=1,N
    1 A(J)=0D0
      RETURN
      END
C
C
      SUBROUTINE SUMA(N,N1,A,X,F)
C
C     Calculates various sums A needed for the least-squares
C     determination of the coefficients W of the linear form
C     F(X)=W1*X1+W2*X2+....+WN*XN(+WN1)
C     If N1=N, there is no absolute term WN1;
C     otherwise set N1=N+1, where N is the dimension of vector X
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),X(1)
C
      M=0
      DO 1 J=1,N
      Q=X(J)
      DO 2 K=J,N
      M=M+1
    2 A(M)=A(M)+Q*X(K)
      IF(N1-N) 4,4,3
    3 M=M+1
      A(M)=A(M)+Q
    4 M=M+1
    1 A(M)=A(M)+Q*F
      IF(N1.EQ.N) RETURN
      M=M+1
      A(M)=A(M)+1D0
      M=M+1
      A(M)=A(M)+F
      RETURN
      END
C
C
      SUBROUTINE RES(N1,A,B,W)
C
C     Determination of the coefficients W of a linear form
C     F(X)=W1*X1+W2*X2+W3*X3+....(+WN)
C     Relevant sums must be calculated before via subroutine SUMA
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),B(1),W(1)
      N0=N1-1
      N2=N1+1
      N3=N1+2
      I=N0*N3
      J1=I+1
      L=0
      M=0
      DO 1 J=1,J1,N3
      L=L+N2
      DO 1 K=J,L
      M=M+1
    1 B(K)=A(M)
      M=N0*N2+1
      J1=1-N3
      DO 3 J=N3,I,N3
      L=J+J1
      DO 2 K=J,M,N2
      L=L+1
    2 B(K)=B(L)
    3 M=M+1
      CALL DP1(B,W,N1)
      RETURN
      END
C
C
      SUBROUTINE DP1(Q,X,K9)
C
C     Solution of a set of linear equations
C     Q1*X1+Q2*X2+Q3*X3+...Q(K9-1)*X(K9)=Q(K9+1)
C     Q(K9+2)*X1+....
C                                  .....=Q(K9*[K9+1])
C
C     X is the vector of results on the output
C     K9 is the number of unknows X
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Q(1),X(1)
      K8=K9
      K10=K9+1
      K11=K8-1
    1 K12=1+K10*K11
      K14=0
      F1=0.0
      K=K12+K9-1
      DO 2 K6=K12,K
      F=DABS(Q(K6))
      IF(F-F1) 2,2,9
    9 F1=F
      K14=K6
    2 CONTINUE
      IF(F1.EQ.0D0) GO TO 8
      F=1D0/Q(K14)
      K13=K10+K12
      K14=K14-K12
      K=K13-1
      DO 3 K6=K12,K
    3 Q(K6)=Q(K6)*F
      IF(K8.NE.1) GO TO 5
      K3=K14+1
      X(K3)=Q(K)
      K11=K11+1
      K16=K9-K11
      IF(K16.EQ.0) RETURN
      K=K10*(K16-1)+K13
      DO 4 K6=K13,K,K10
      K1=K6+K10-1
      K2=K6+K14
      Q(K1)=Q(K1)-Q(K2)*X(K3)
    4 Q(K2)=0.0
      GO TO 1
    5 K8=K8-1
      K11=K8-1
      K=K10*K11+1
      DO 6 K5=1,K,K10
      L=K5+K14
      F=Q(L)
      K1=K5+K10-1
      DO 6 K6=K5,K1
      K7=K6-K5+K12
      F1=Q(K7)*F
    6 Q(K6)=Q(K6)-F1
      K14=K14+1
      K=K14+K10*K11
      DO 7 K6=K14,K,K10
    7 Q(K6)=0.0
      GO TO 1
    8 WRITE(9,100) K9
  100 FORMAT(/5X,'A SINGULARITY IN THE SOLUTION OF',I4,
     1       ' LINEAR EQUATIONS IN SUBROUTINE DP1'/)
      STOP 13
      RETURN
      END
C
C     Solution of cubic algebraic equation
C
C           3       2
C     W(1)*X +W(2)*X +W(3)*X+W(4)=0
C
      SUBROUTINE KUBA(W,X)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION W(4),X(3)
C
      A=W(2)/W(1)
      B=W(3)/W(1)
      C=W(4)/W(1)
      R=A/3D0
      P=B-R*A
      Q=R*(2D0*A*A/9D0-B)+C
      T=5D-1*Q
      S=P/3D0
      D=T*T+S*S*S
      IF(D.LT.0) GO TO 1
      U=DSQRT(D)
      V=-U-T
      U=U-T
      U=DSIGN(DABS(U)**0.333333333333333D0,U)
      V=DSIGN(DABS(V)**0.333333333333333D0,V)
      X(1)=U+V-R
      RETURN
    1 H=DABS(S)
      F=DACOS(-T/DSQRT(H*H*H))
      G=2D0*DSQRT(H)
      X(1)=G*DCOS(F/3D0)-R
      X(2)=-G*DCOS(F/3D0-1.047197551D0)-R
      X(3)=-G*DCOS(F/3D0+1.047197551D0)-R
      RETURN
      END
C                                                                       REL.13
C                                                                       REL.13
C     SORTING GENERAL RECORDS BY SHELL'S METHOD                         REL.13
C                                                                       REL.13
      SUBROUTINE GENSHL(N,ORDER,MOVE)                                   REL.13
C     N=NUMBER OF SORTED RECORDS                                        REL.13
C     LOGICAL FUNCTION ORDER(I,J) TESTS WHETHER I-TH RECORD IS IN RIGHT REL.13
C     ORDER COMPARED WITH J-TH RECORD (USER SUPPLIED)                   REL.13
C     SUBROUTINE MOVE(I,J) MOVES I-TH RECORD INTO J-TH ONE              REL.13
C     (USER SUPPLIED)                                                   REL.13
C     BOTH USER SUPPLIED SUBPROGRAMS MAY BE CALLED WITH I OR J          REL.13
C     EQUAL TO (N+1), IN THAT CASE PLACE FOR TEMPORARY (WORKING)        REL.13
C     RECORD IS REFERENCED, USER MUST PROVIDE SPACE FOR THIS RECORD     REL.13
C     INTEGER N,D,I,J,I1,I2,N1                                          REL.13
      LOGICAL ORDER                                                     REL.13
      N1=N+1                                                            REL.13
      I=1                                                               REL.13
    6 I1=I+I                                                            REL.13
      IF(I1.GT.N) GO TO 7                                               REL.13
      I=I1                                                              REL.13
      GO TO 6                                                           REL.13
    7 D=I-1                                                             REL.13
    1 IF(D.LE.0)RETURN                                                  REL.13
      I=1                                                               REL.13
    2 J=I                                                               REL.13
      I1=I+D                                                            REL.13
      CALL MOVE(I1,N1)                                                  REL.13
    3 IF(ORDER(N1,J)) GO TO 4                                           REL.13
    5 I2=J+D                                                            REL.13
      CALL MOVE(N1,I2)                                                  REL.13
      I=I+1                                                             REL.13
      IF(I+D.LE.N) GO TO 2                                              REL.13
      D=(D-1)/2                                                         REL.13
      GO TO 1                                                           REL.13
    4 I2=J+D                                                            REL.13
      CALL MOVE(J,I2)                                                   REL.13
      J=J-D                                                             REL.13
      IF(J)5,5,3                                                        REL.13
      END                                                               REL.13
C                                                                       REL.13
C                                                                       REL.13
C                                                                       REL.13
      SUBROUTINE MOVE(I,J)                                              REL.13
      IMPLICIT REAL*8 (A-H,O-Z)                                         REL.13
      INTEGER*2 NT                                                      REL.13
C
C$LARGE: S,V,TT,VV,C,NK,NKK,NH,IHD,NT                                    REL.15
C
      COMMON /DATA/ STRED,U(32),UI(32),DIG,VEX(4),                      REL.18
     *   S(100000,4),V(100000,4),PAS,TT(100000,4),VV(100000,4),         REL.18
     *   C(4,2000),B(12),G(28),VJ(4),BR(6),AVE,                         REL.18
     *   EXT(4),NM(4),NC,NS,NK(100000,4),NKK(100000,4),NH(2000,4),      REL.18
     *   NMIN,NMAX,NDIG,NKAL,IHD(2000),NT(2000)                         REL.18
      DO 1 K=1,NC                                                       REL.13
      TT(J,K)=TT(I,K)                                                   REL.13
      VV(J,K)=VV(I,K)                                                   REL.13
      NKK(J,K)=NKK(I,K)                                                 REL.13
    1 CONTINUE                                                          REL.13
      RETURN                                                            REL.13
      END                                                               REL.13
C                                                                       REL.13
C                                                                       REL.13
C                                                                       REL.13
      LOGICAL FUNCTION ORDER(I,J)                                       REL.13
      IMPLICIT REAL*8 (A-H,O-Z)                                         REL.13
      INTEGER*2 NT                                                      REL.13
C
C$LARGE: S,V,TT,VV,C,NK,NKK,NH,IHD,NT                                    REL.15
C
      COMMON /DATA/ STRED,U(32),UI(32),DIG,VEX(4),                      REL.18
     *   S(100000,4),V(100000,4),PAS,TT(100000,4),VV(100000,4),         REL.18
     *   C(4,2000),B(12),G(28),VJ(4),BR(6),AVE,                         REL.18
     *   EXT(4),NM(4),NC,NS,NK(100000,4),NKK(100000,4),NH(2000,4),      REL.18
     *   NMIN,NMAX,NDIG,NKAL,IHD(2000),NT(2000)                         REL.18
      ORDER=TT(I,2).LE.TT(J,2)                                          REL.13
      RETURN                                                            REL.13
      END                                                               REL.13
C
C
C
      SUBROUTINE GRAF(KEY,NC,MSYS,A,V)                                  REL.18
C                                                                       REL.14
      IMPLICIT REAL*8 (A-H,O-Z)                                         REL.14
C
C$LARGE: X,Y,G
C
      DIMENSION X(10000),Y(10000,4),V(4),YMIN(4),YMAX(4),QY(4)          REL.18
      CHARACTER*1 MEZ,Z(3),Z1(4),Z2(4),Z3(3),G(80,24)                   REL.18
C                                                                       REL.14
      DATA MEZ/1H /                                                     REL.18
      DATA Z/1HV,1HB,1HU/                                               REL.18
      DATA Z1/1Hy,1Hb,1Hu,1Hv/                                          REL.18
      DATA Z2/1HV,1HB,1HU,1HR/                                          REL.18
      DATA Z3/1HV,1HB,1HR/                                              REL.18
C                                                                       REL.14
      IF(KEY.NE.0) GO TO 1                                              REL.14
      N=0                                                               REL.14
      XMIN=1D50                                                         REL.14
      XMAX=-1D50                                                        REL.14
      DO 2 J=1,NC                                                       REL.14
      YMIN(J)=1D50                                                      REL.14
    2 YMAX(J)=-1D50                                                     REL.14
      DO 10 K=1,24                                                      REL.14
      DO 10 J=1,80                                                      REL.14
   10 G(J,K)=MEZ                                                        REL.14
      RETURN                                                            REL.14
C                                                                       REL.14
    1 IF(KEY.NE.1) GO TO 7                                              REL.14
      N=N+1                                                             REL.14
      IF(A.LT.XMIN) XMIN=A                                              REL.14
      IF(A.GT.XMAX) XMAX=A                                              REL.14
      DO 4 J=1,NC                                                       REL.14
      IF(V(J).LT.YMIN(J)) YMIN(J)=V(J)                                  REL.14
      IF(V(J).GT.YMAX(J)) YMAX(J)=V(J)                                  REL.14
    4 CONTINUE                                                          REL.14
      X(N)=A                                                            REL.14
      DO 3 J=1,NC                                                       REL.14
    3 Y(N,J)=V(J)                                                       REL.14
      RETURN                                                            REL.14
C                                                                       REL.14
    7 XXX=XMAX-XMIN                                                     REL.17.1
      IF(XXX.GT.0D0) GO TO 6                                            REL.17.1
      WRITE(9,301)                                                      REL.17.1
  301 FORMAT(/' All extinction-star data at the same time: No plot')    REL.17.1
      RETURN                                                            REL.17.1
C                                                                       REL.17.1
    6 QX=76D0/(XXX)                                                     REL.17.1
      DO 5 J=1,NC                                                       REL.14
    5 QY(J)=20D0/(YMAX(J)-YMIN(J))                                      REL.14
      DO 18 J=1,N                                                       REL.14
      JX=2+QX*(X(J)-XMIN)                                               REL.14
      JY=2+QY(1)*(Y(J,1)-YMIN(1))                                       REL.14
      IF(NC.EQ.3.AND.MSYS.EQ.3) G(JX,JY)=Z(1)                           REL.18
      IF(NC.EQ.3.AND.MSYS.EQ.1) G(JX,JY)=Z3(1)                          REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.3) G(JX,JY)=Z1(1)                          REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.1) G(JX,JY)=Z2(1)                          REL.18
   18 CONTINUE
      WRITE(9,201) XMIN,XMAX,YMIN(1),YMAX(1)                            REL.14
  201 FORMAT(80(1H-)/'1.magnitude O-C:',5X,' X range: ',2F7.4,          REL.14
     *       5X,' Y range: ',2F6.3/80(1H-)/)                            REL.14
      DO 19 K=22,1,-1                                                   REL.14
   19 WRITE(9,200) (G(J,K),J=1,80)                                      REL.14
  200 FORMAT(80A1)                                                      REL.14
C                                                                       REL.14
      IF(NC.LT.2) RETURN                                                REL.14
      DO 20 K=1,24                                                      REL.14
      DO 20 J=1,80                                                      REL.14
   20 G(J,K)=MEZ                                                        REL.18
      DO 28 J=1,N                                                       REL.14
      JX=2+QX*(X(J)-XMIN)                                               REL.14
      JY=2+QY(2)*(Y(J,2)-YMIN(2))                                       REL.14
      IF(NC.EQ.3.AND.MSYS.EQ.3) G(JX,JY)=Z(2)                           REL.18
      IF(NC.EQ.3.AND.MSYS.EQ.1) G(JX,JY)=Z3(2)                          REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.3) G(JX,JY)=Z1(2)                          REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.1) G(JX,JY)=Z2(2)                          REL.18
   28 CONTINUE                                                          REL.18
      WRITE(9,202) XMIN,XMAX,YMIN(2),YMAX(2)                            REL.14
  202 FORMAT(80(1H-)/'2.magnitude O-C:',5X,' X range: ',2F7.4,          REL.14
     *       5X,' Y range: ',2F6.3/80(1H-)/)                            REL.14
      DO 29 K=22,1,-1                                                   REL.14
   29 WRITE(9,200) (G(J,K),J=1,80)                                      REL.14
C                                                                       REL.14
      IF(NC.LT.3) RETURN                                                REL.14
      DO 30 K=1,24                                                      REL.14
      DO 30 J=1,80                                                      REL.14
   30 G(J,K)=MEZ                                                        REL.18
      DO 38 J=1,N                                                       REL.14
      JX=2+QX*(X(J)-XMIN)                                               REL.14
      JY=2+QY(3)*(Y(J,3)-YMIN(3))                                       REL.14
      IF(NC.EQ.3.AND.MSYS.EQ.3) G(JX,JY)=Z(3)                           REL.18
      IF(NC.EQ.3.AND.MSYS.EQ.1) G(JX,JY)=Z3(3)                          REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.3) G(JX,JY)=Z1(3)                          REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.1) G(JX,JY)=Z2(3)                          REL.18
   38 CONTINUE                                                          REL.18
      WRITE(9,203) XMIN,XMAX,YMIN(3),YMAX(3)                            REL.14
  203 FORMAT(80(1H-)/'3.magnitude O-C:',5X,' X range: ',2F7.4,          REL.14
     *       5X,' Y range: ',2F6.3/80(1H-)/)                            REL.14
      DO 39 K=22,1,-1                                                   REL.14
   39 WRITE(9,200) (G(J,K),J=1,80)                                      REL.14
C                                                                       REL.14
      IF(NC.LT.4) RETURN                                                REL.14
      DO 40 K=1,24                                                      REL.14
      DO 40 J=1,80                                                      REL.14
   40 G(J,K)=MEZ                                                        REL.18
      DO 48 J=1,N                                                       REL.14
      JX=2+QX*(X(J)-XMIN)                                               REL.14
      JY=2+QY(4)*(Y(J,4)-YMIN(4))                                       REL.14
      IF(NC.EQ.4.AND.MSYS.EQ.3) G(JX,JY)=Z1(4)                          REL.18
      IF(NC.EQ.4.AND.MSYS.EQ.1) G(JX,JY)=Z2(4)                          REL.18
   48 CONTINUE                                                          REL.18
      WRITE(9,204) XMIN,XMAX,YMIN(4),YMAX(4)                            REL.14
  204 FORMAT(80(1H-)/'4.magnitude O-C:',5X,' X range: ',2F7.4,          REL.18
     *       5X,' Y range: ',2F6.3/80(1H-)/)                            REL.14
      DO 49 K=22,1,-1                                                   REL.14
   49 WRITE(9,200) (G(J,K),J=1,80)                                      REL.14
      RETURN                                                            REL.14
      END                                                               REL.14
