C
C
C     Transforming Tug photometry into Data B of HEC22
C
C     File TUG.CON must contain UBV (uvby).TAB numbers of observed stars
C                  in an increasing order v, c1, c2, c3, c4, etc...
C
C     TUG22  release 3.1
C
C     This is a modified version which takes into account the fact 
C     that the times recorded at TUG refer to the   e n d   of the last 
C     of the three consecutive integrations
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION V(3),TX(5)
      INTEGER*2 NS(40)
      CHARACTER*1 ZN(3),Z,ST(3),UVBY(4),UBV(3),COL
      CHARACTER*6 NGT
      CHARACTER*8 OBS
      CHARACTER*12 INP,OUT
C
      COMMON /DTC/ DT
C
C     Definition of special data values
C
      DATA ZN/1H:,1H ,1HS/
      DATA UBV/1HV,1HB,1HU/
      DATA UVBY/1Hy,1Hb,1Hu,1Hv/
      DT=4D-8
C
C     Input formats
C
  101 FORMAT(A1)
  102 FORMAT(3A1,1X,A1,3F5.0,2(1X,I2),1X,F2.0)
  112 FORMAT(1X,I1,2X,A1,3F5.0,2(1X,I2),1X,F2.0)
  103 FORMAT(A1,3A4)
  104 FORMAT(A1,3I2,I3,I2,I3,I2,F9.0,I2)
C
C     Output formats
C
  201 FORMAT(10A8)
  202 FORMAT(5A8)
  203 FORMAT(F3.0,I3,I5,4H 366)
  204 FORMAT(I1,I4,2I3,F9.4,F10.4)
  205 FORMAT(5H    0)
  206 FORMAT('2.02222222'23X,'36.',7X,'51.',19X,'0.0',2X,'Tubitak')
  207 FORMAT('Night ',A6,' TUG 0.4-m UBV 'A8,1X)
C
      PRINT *,'Creating HEC22 type B data  Rel. 2.0  November 10, 1998'
C
      PRINT *,'Input file of TUG data?'
      READ(*,'(A)') INP
      PRINT *,'Output HEC22 data file?'
      READ(*,'(A)') OUT
      OPEN(1,FILE=INP,STATUS='OLD')
      OPEN(2,FILE=OUT,STATUS='NEW')
      OPEN(3,FILE='TUG.CON',STATUS='OLD')
C
C
      PRINT *,'Night No.? (max. 6 characters, e.g.: 25/92)'
      READ(*,'(A)') NGT
      PRINT *,'Observer? (max. 8 characters)'
      READ(*,'(A)') OBS
      WRITE(2,207) NGT,OBS
      WRITE(*,207) NGT,OBS
      PRINT *,'Comments on quality, weather etc. [max. 40 characters!]'
      PRINT *,'<                                     >'
      READ(*,201) TX
      WRITE(2,202) TX
      PRINT *,'Date of the beginning of night?'
      READ(*,*) D,M,J
      PRINT *,'Integration time in sec.?'
      READ(*,*) SEC
      WRITE(2,203) D,M,J
      WRITE(2,206)
C
      READ(3,*,END=1) NS
C
    1 READ(1,101,END=10) Z
      IF(Z.EQ.ZN(1)) GO TO 1
      IF(Z.EQ.ZN(2)) GO TO 1
      BACKSPACE 1
C
    2 READ(1,102) ST,COL,V,JH,JM,S
      IF(ST(2).NE.ZN(3).AND.ST(3).NE.ZN(3)) GO TO 6
      L=-1
      GO TO 7
    6 BACKSPACE 1
      READ(1,112) L,COL,V,JH,JM,S
      L=NS(L+1)
    7 K=1313
      DO 3 J=1,3
      IF(COL.EQ.UBV(J)) K=J
    3 CONTINUE
      DO 4 J=1,4
      IF(COL.EQ.UVBY(J)) K=J
    4 CONTINUE
      IF(K.LT.1313) GO TO 5
      WRITE(2,301) COL,JH,JM,S
  301 FORMAT(' Error 1: Unknown filter code',A2,' at time',
     *       2I3,F4.1)
      GO TO 1
    5 W=0.33333333333333333333D0*(V(1)+V(2)+V(3))/SEC
      Q=JH+JM/60D0+(S-1.5D0*SEC)/3600D0
      IF(Q.LT.0D0) Q=Q+24D0
      JH=Q
      Q=60D0*(Q-JH)
      JM=Q
      S=60D0*(Q-JM)
      WRITE(2,204) K,L,JH,JM,S,W
      GO TO 1
C
C
   10 WRITE(2,205)
      STOP 7
      END
