C
C
C     Transforming Xing-Long photometry into Data B of HEC22
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TEX(10)
      INTEGER*2 NS(100)
      CHARACTER*1 F,FL(3)
      CHARACTER*4 OBJ,NAM(100)
      CHARACTER*12 IN,INP,OUT
C
C
C     Definition of special data values
C
      DATA FL/1HV,1HB,1HU/
C
C     Input formats
C
  100 FORMAT(6X,A4,2X,A1,I4,2F9.4)
  101 FORMAT(26X,A6)
  102 FORMAT(7X,3F3.0)
  103 FORMAT(A4,I3)
  104 FORMAT(10A8)
C
C     Output formats
C
  201 FORMAT(I1,1X,I3,2I3,F9.5,F10.5)
  202 FORMAT(5A8)
  203 FORMAT(F3.0,I3,I5,4H 308)
  205 FORMAT(5H    0)
C
C     Formats of error messages
C
  301 FORMAT(' Error: Star ',A5,' is missing in conversion table')
  302 FORMAT(' Error: Incorrect filter coded at time',F8.4)
C
      PRINT *,'Creating HEC22 type B data  Rel. 1  November 11, 1994'
C
      PRINT *,'Input file of the conversion table of objects?'
      READ(*,'(A)') IN
      PRINT *,'Input file of Xing-Long data?'
      READ(*,'(A)') INP
      PRINT *,'Output HEC22 data file?'
      READ(*,'(A)') OUT
      OPEN(1,FILE=INP,STATUS='OLD')
      OPEN(2,FILE=OUT,STATUS='NEW')
      OPEN(3,FILE=IN,STATUS='OLD')
C
C     Input of data header and date of observation
C
      READ(1,104) TEX
      WRITE(2,202) TEX
      READ(1,*) D,M,LP 
      WRITE(2,203) D,M,LP 
C
C     Input of table of star names and specifications
C
      NN=0
    4 READ(3,103,END=1) OBJ,K
      NN=NN+1
      NAM(NN)=OBJ
      NS(NN)=K
      GO TO 4
C
C     Input of observations begins
C
C
    1 READ(1,100,END=10) OBJ,F,IT,H,V
      DO 5 I=1,NN
      N=I
      IF(OBJ.EQ.NAM(N)) GO TO 6
    5 CONTINUE
      WRITE(*,301) OBJ
      STOP 13
    6 DO 3 I=1,3
      L=I
      IF(F.EQ.FL(I)) GO TO 2
    3 CONTINUE
      WRITE(2,302) H
      STOP 13
    2 J=H
      H=60D0*(H-J)
      K=H
      H=60D0*(H-K)
      V=V/IT
      WRITE(2,201) L,NS(N),J,K,H,V
      GO TO 1
C
C
   10 WRITE(2,205)
      STOP 7
      END
